SystemOrganization addCategory: #'MarkupBuilder-Core'!
SystemOrganization addCategory: #'MarkupBuilder-Tests'!
SystemOrganization addCategory: #'MarkupBuilder-XML'!
SystemOrganization addCategory: #'MarkupBuilder-Others'!
SystemOrganization addCategory: #'MarkupBuilder-XML-Plugins'!
SystemOrganization addCategory: #'MarkupBuilder-Utils'!

Dictionary subclass: #SortedDictionary
	instanceVariableNames: 'sortedKeyCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Others'!

!SortedDictionary class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/18/2010 10:18'!
new

| newInstance |
newInstance := super new.
newInstance initialize.
^newInstance
! !

!SortedDictionary methodsFor: 'as yet unclassified' stamp: 'Skrish 7/18/2010 10:21'!
add: aKeyAndValue

sortedKeyCollection addLast: aKeyAndValue key.
^super add: aKeyAndValue ! !

!SortedDictionary methodsFor: 'as yet unclassified' stamp: 'Skrish 7/18/2010 10:19'!
at: aKey put: aValue

sortedKeyCollection addLast: aKey.
^super at: aKey put: aValue! !

!SortedDictionary methodsFor: 'as yet unclassified' stamp: 'Skrish 7/18/2010 10:18'!
initialize

sortedKeyCollection := SortedCollection new.! !

Error subclass: #MarkupBuilderError
	instanceVariableNames: ''
	classVariableNames: 'MarkupErrorDictionary'
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

!MarkupBuilderError class methodsFor: 'error dictionary' stamp: 'Skrish 7/26/2010 00:35'!
MarkupErrorDictionary
	^ MarkupErrorDictionary! !

!MarkupBuilderError class methodsFor: 'error dictionary' stamp: 'Skrish 7/26/2010 13:36'!
errorTextArray
	"should we go for a properties string to be read in.."

	^ {(#elementsNotEmptyIfCNodeNotNil -> 'Elements cannot be empty if cNodeBlk isNotNil').
	(#htmlTableHeaderOrientType -> 'orient: can be only #top or #left').
	(#valueStreamBeSetByHtmlBuilder -> 'valueStream should be set by HtmlBuilder').
	(#cNodeNotBlockType -> 'cNode argument is not of type Block..').
	(#bldrAllowedArgs -> 'Builder methods are tag:cNode: only..').
	(#bldrMaxArgs -> 'Max two args are permitted').
	(#xmlAddlStmtPrefixNotValid -> 'XML addl stmt prefix not valid').
	(#attributesNotNil -> 'Attributes should be nil to assign to it').
	(#htmlTableCsvHeaderRowSymbol -> 'Html Table from Csv headerSymbol should be topRow or default').
	(#pluginMissingMethodError -> 'Plugin class: <1s> is missing this invoked method: <2s>').
	(#csvFolderNotValid -> 'Check if you have valid folderName as defined in method #csvFileFolderName').
	(#csvFolderNotValid1 -> 'Check if you have valid folderName as defined in method #csvFileFolderName for: <1s>').
	(#csvFilesNotFound1->	'Cannot proceed as there is no csvfile read..Check if you have *.csv files 
		in the folderName as defined in method #csvFileFolderName: <1s>').
	(#csvFileNotValid1 -> 'CSV file not valid: Error on stream for file: <1s>')}! !

!MarkupBuilderError class methodsFor: 'error dictionary' stamp: 'Skrish 7/26/2010 14:35'!
errorTextDictionary
	
	self flag: #checkToDo.
	"should we go for a properties string to be read in.. and cached return once this is stable"

	self resetErrorTextDictionary.
	self errorTextArray do: [ :ea | MarkupErrorDictionary add: ea ].
	^ MarkupErrorDictionary! !

!MarkupBuilderError class methodsFor: 'initialize-release' stamp: 'Skrish 7/26/2010 00:36'!
initialize
	MarkupErrorDictionary := self errorTextDictionary! !

!MarkupBuilderError class methodsFor: 'error dictionary' stamp: 'Skrish 7/10/2010 07:58'!
resetErrorTextDictionary

	MarkupErrorDictionary := Dictionary new.! !

!MarkupBuilderError class methodsFor: 'raise error' stamp: 'Skrish 7/26/2010 00:37'!
signalError: errorSymbol
	"standard form"

	self signal: (self MarkupErrorDictionary at: errorSymbol)! !

!MarkupBuilderError class methodsFor: 'raise error' stamp: 'Skrish 7/26/2010 00:37'!
signalError: errorSymbol expandMacrosWithArguments: argsArray
	"expand.."

	self signal: ((self MarkupErrorDictionary at: errorSymbol) expandMacrosWithArguments: argsArray)! !

Warning subclass: #MarkupBuilderWarning
	instanceVariableNames: ''
	classVariableNames: 'MarkupWarningDictionary'
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

!MarkupBuilderWarning class methodsFor: 'warnings' stamp: 'Skrish 7/26/2010 00:37'!
MarkupWarningDictionary
	^ MarkupWarningDictionary! !

!MarkupBuilderWarning class methodsFor: 'warnings' stamp: 'Skrish 7/26/2010 00:37'!
initialize
	MarkupWarningDictionary := self warningTextDictionary! !

!MarkupBuilderWarning class methodsFor: 'warnings' stamp: 'Skrish 7/16/2010 19:28'!
resetWarningTextDictionary
	
	
	MarkupWarningDictionary := Dictionary new.
		! !

!MarkupBuilderWarning class methodsFor: 'warnings' stamp: 'Skrish 7/26/2010 00:38'!
signalWarn: errorSymbol
	"standard form.."

	self signal: (self MarkupWarningDictionary at: errorSymbol)! !

!MarkupBuilderWarning class methodsFor: 'warnings' stamp: 'Skrish 7/26/2010 00:38'!
signalWarn: errorSymbol expandMacrosWithArguments: argsArray
	"expand.."
	
	self signal: ((self MarkupWarningDictionary at: errorSymbol) expandMacrosWithArguments: argsArray)! !

!MarkupBuilderWarning class methodsFor: 'warnings' stamp: 'Skrish 7/26/2010 00:38'!
warningTextDictionary
	"for now.. can extend/ refactor this like MarkupBuilderError"

	self resetWarningTextDictionary.
	^ MarkupWarningDictionary
		add: #pluginMissingMethodError -> 'Plugin class: <1s> is missing this invoked method: <2s>';
		yourself! !

WAComponent subclass: #HtmlBuilderComponent
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:24'!
builder
	builder ifNil: [ builder := HtmlBuilder new ].
	^ builder! !

!HtmlBuilderComponent methodsFor: 'error_handling' stamp: 'Skrish 7/26/2010 14:23'!
errorCssStyle

^{#style->'color: darkRed; background-color:#ffbbbb; width:50%; border: 1px; border-style:solid; border-color:#ff0000 ' }! !

!HtmlBuilderComponent methodsFor: 'private' stamp: 'Skrish 7/26/2010 14:23'!
escapeHtmlChars: aHtmlString
	^ (aHtmlString copyReplaceAll: '<' with: '&lt;') copyReplaceAll: '>' with: '&gt;'! !

!HtmlBuilderComponent methodsFor: 'error_handling' stamp: 'Skrish 7/26/2010 14:23'!
sendErrorText: text

	builder attributes: self errorCssStyle ;
		h5: text.
	^builder! !

!HtmlBuilderComponent methodsFor: 'error_handling' stamp: 'Skrish 7/26/2010 14:23'!
sendErrorText: aSymbol with: argsArray

	builder attributes: self errorCssStyle ;
		h5: ((MarkupBuilderError errorTextDictionary  at: aSymbol) expandMacrosWithArguments: argsArray).
	^builder! !

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 00:49'!
setNewDocument: aRenderContext with: aBuilder
	| aStream |
	aStream := aRenderContext document stream.
	aStream initalizeOn: aBuilder valueStream! !

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/25/2010 10:02'!
storeActionCallback: aBlock on: aRenderContext
	| actionOrValueBlk  |

	actionOrValueBlk := aRenderContext callbacks store: (WAActionCallback on: aBlock).
	^aRenderContext actionBaseUrl copy addField: actionOrValueBlk
! !

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/25/2010 10:02'!
storeActionCallback: aBlock on: aRenderContext value: aValue
	| actionOrValueBlk  |

	actionOrValueBlk := aRenderContext callbacks store: (WAActionCallback on: aBlock).
	^aRenderContext actionBaseUrl copy addField: actionOrValueBlk value: aValue.
! !

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/25/2010 10:02'!
storeValueCallback: aBlock on: aRenderContext 
	| actionOrValueBlk hrefUrl |
	actionOrValueBlk := aRenderContext callbacks store: (WAValueCallback on: aBlock).
	hrefUrl := aRenderContext actionUrl addField:  actionOrValueBlk.
	^actionOrValueBlk! !

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/25/2010 10:01'!
storeValueCallback: aBlock on: aRenderContext value: aValue
	| actionOrValueBlk hrefUrl |
	actionOrValueBlk := aRenderContext callbacks store: (WAValueCallback on: aBlock).
	hrefUrl := aRenderContext actionUrl addField:  actionOrValueBlk value: aValue.
	^actionOrValueBlk! !

!HtmlBuilderComponent methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:09'!
streamContentsFor: aRenderContext
	| aStream |
	aStream := aRenderContext document stream.
	aStream nextPutAll: builder valueStream contents! !

HtmlBuilderComponent subclass: #TestHtmlBuilder
	instanceVariableNames: 'aSelector builderTestsCreateSelectors inputType csvFileName htmlErrorTextDictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

TestHtmlBuilder subclass: #TestBeanBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!TestBeanBuilder class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/15/2010 09:56'!
initialize


WAAdmin register: self asApplicationAt: 'TestBeanBuilder'  
! !

!TestBeanBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:28'!
displayXmlString
	| xmlBuilderTests xmlString xmlBuilder |
	xmlBuilderTests := self testClass new aSimpleBean: (Trial new markupBuilder: XMLBuilder new).
	xmlString := self escapeHtmlChars: (xmlBuilderTests perform: aSelector) xmlString. 
	(xmlBuilder := XMLBuilder new)
		attributes: #('style="color:darkred;font-family:''Times New Roman'';font-weight:bold;"');
		h5: 'XML Indented for easier readability...';
		pre: xmlString.
	^ xmlBuilder! !

!TestBeanBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:13'!
homeLinksFor: aRenderContext
	"links below the page to toggle between a test anchor/ home"

	builder hr.

	(builder attributesMap
		href: self class name;
		parent)
		a: 'Home: Random method';
		br.
	(builder attributesMap
		href: 'TestHtmlBuilder';
		parent)
		a: 'TestHtmlBuilder';
		br.	
			
! !

!TestBeanBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:13'!
renderContentOn: html
	| xmlBuilder aRenderContext |
	aRenderContext := html context.
	aSelector := self chooseSelector.
	html heading: aSelector level: 3.	"self halt"
	xmlBuilder := self displayXmlString.
	builder := HtmlBuilder new valueStream: xmlBuilder valueStream.
	self chooseSelectorFormFor: aRenderContext.
	self homeLinksFor: aRenderContext.
	self showSource.
	self streamContentsFor: aRenderContext.
	aSelector := nil! !

!TestBeanBuilder methodsFor: 'private' stamp: 'Skrish 7/15/2010 09:54'!
testClass

^PropertiesBeanTests! !

!TestHtmlBuilder class methodsFor: 'init' stamp: 'Skrish 7/10/2010 10:47'!
initialize


WAAdmin register: self asApplicationAt: 'TestHtmlBuilder'  
! !

!TestHtmlBuilder methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 19:11'!
aSelector
	^ aSelector! !

!TestHtmlBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:46'!
aSelector: anObject
	(anObject notNil and: [ anObject notEmpty ])
		ifTrue: [ aSelector := anObject asSymbol ]! !

!TestHtmlBuilder methodsFor: 'private' stamp: 'Skrish 7/15/2010 10:21'!
builderTestsCreateSelectors
	""

	builderTestsCreateSelectors 
		ifNil: [ builderTestsCreateSelectors := (self testClass methodDict keys select: [ :ea | ea beginsWith: 'create' ]) asSortedCollection ].
	^ builderTestsCreateSelectors! !

!TestHtmlBuilder methodsFor: 'private' stamp: 'Skrish 7/25/2010 16:46'!
chooseSelector

	| indx |
	aSelector isNil 
		ifTrue: [ indx := (Time millisecondClockValue \\self builderTestsCreateSelectors size) max: 1.
			aSelector := self builderTestsCreateSelectors at: indx ].
	^ aSelector! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:21'!
chooseSelectorFormFieldsFor: aRenderContext
	| callbackField |
	callbackField := self storeValueCallback: [ :val |  ( val notNil and: [val notEmpty ])
												      					ifTrue:[self aSelector: val] ] on: aRenderContext.
	builder hr; 
			 h5: 'HtmlBuilderTests createHtml methods: Select one to render above..'.
	(builder attributesMap
		name: callbackField;
		parent) select: '' optionCNodes: self valuesTextAndSelectedDictionaryColl.
	(builder attributesMap
		type: 'submit';
		value: 'submit';
		parent) input! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:04'!
chooseSelectorFormFor: aRenderContext 
	"for the form to be rendered..."

	(builder attributesMap
		action: aRenderContext actionUrl;
		method: 'post'; 
		parent)
		form: ''
		with: [self chooseSelectorFormFieldsFor: aRenderContext]! !

!TestHtmlBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:46'!
csvFileName: anObject
	(anObject notNil and: [ anObject notEmpty ])
		ifTrue: [ csvFileName := anObject ]! !

!TestHtmlBuilder methodsFor: 'create_html' stamp: 'Skrish 7/26/2010 13:24'!
generateTableData
	| rowsData |
	rowsData := OrderedCollection new.
	1 to: 67 do: [ :ea | 
		rowsData
			add:
				{('firstCell_' , ea asString).
				ea.
				('Col3_' , ea asString).
				('Col4_' , ea asString)} ].
	^ rowsData! !

!TestHtmlBuilder methodsFor: 'render_homelinks' stamp: 'Skrish 7/26/2010 14:14'!
homeLinksFor: aRenderContext
	"links below the page to toggle between a test anchor/ home"

	| testAnchorHref  callbackField optionsColl |
	builder hr.
	
	self homeLinksOfPaginatedTableFor: aRenderContext .
	self renderBaseHomeLinks: builder! !

!TestHtmlBuilder methodsFor: 'render_homelinks' stamp: 'Skrish 7/26/2010 14:15'!
homeLinksOfPaginatedTableFor: aRenderContext 

	| testAnchorHref   |
	testAnchorHref := self storeActionCallback: [ aSelector := #testTablePaginateFor: ] on: aRenderContext.

	(builder attributesMap
		href: testAnchorHref;
		parent)
		a: 'Test Paginated Table'.
	(builder attributesMap
		action: aRenderContext actionUrl;
		method: 'post'; 
		parent)
		form: ''
		with: [ self renderTextInputTypeSelectionsFor: aRenderContext ].! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/16/2010 16:48'!
initializeBuilder

	builder ifNil: [ builder := HtmlBuilder new].
	builder valueStream reset.
	builder styleScript: HtmlBuilderCss defaultTableCss.! !

!TestHtmlBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:46'!
inputType: anObject
	(anObject notNil and: [ anObject notEmpty ])
		ifTrue: [ inputType := anObject ]! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/16/2010 16:58'!
invokePageForTableFor: aRenderContext
	| paginatePlugin |
	paginatePlugin := builder defaultHtmlTable pluginInstance pluginRegistryAt: #Paginate.
	(paginatePlugin notNil and: [ paginatePlugin pluginBlockInvoked ])
		ifTrue: [ 
			builder defaultHtmlTable renderTable."just render the table for the currentPage set.."
			paginatePlugin pluginBlockInvoked: false ]
		ifFalse: [ ^ nil ]! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:18'!
performTestSelector
	self builder valueStream reset.
	(HtmlBuilderTests new)
		htmlBuilder: builder;
		perform: aSelector! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/18/2010 21:02'!
performTestTablePaginateFor: aRenderContext
	| paginatePlugin |

	self builder valueStream reset.
	builder styleScript: HtmlBuilderCss defaultTableCss.
	(self invokePageForTableFor: aRenderContext)
		ifNil: [ self renderNewTableFor: aRenderContext ]! !

!TestHtmlBuilder methodsFor: 'render_homelinks' stamp: 'Skrish 7/23/2010 19:06'!
renderBaseHomeLinks: aBuilder

	(aBuilder attributesMap
		href: self class name;
		parent)
		a: 'Home: Random method';
		br.
	self class subclasses do: [ :eaClass | 
		(aBuilder attributesMap
		href: eaClass;
		parent)
		a: eaClass name asString;
		br.
		].	
	aBuilder 
		hr.				
! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:18'!
renderContentOn: html
	| aRenderContext |
	aRenderContext := html context.
	aSelector := self chooseSelector.
	html heading: aSelector level: 3.
	[ 
	(aSelector beginsWith: #testTablePaginateFor:)
		ifTrue: [ self performTestTablePaginateFor: aRenderContext ]
		ifFalse: [ self performTestSelector ].
	self chooseSelectorFormFor: aRenderContext.
	self homeLinksFor: aRenderContext ] on: MarkupBuilderError do: [ :ex | self sendErrorText: ex description ].
	self showSource.
	self streamContentsFor: aRenderContext.
	(aSelector beginsWith: #testTablePaginateFor:)
		ifFalse: [ aSelector := nil ]! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/16/2010 16:52'!
renderNewTableFor: aRenderContext
	inputType ifNil: [ inputType := #text ].
	aSelector = #testTablePaginateFor:
		ifTrue: [ ^ self testTablePaginateFor: aRenderContext ].
	aSelector = #testTablePaginateFor:tableCellInputType:
		ifTrue: [ ^ self testTablePaginateFor: aRenderContext tableCellInputType: inputType ]! !

!TestHtmlBuilder methodsFor: 'render_homelinks' stamp: 'Skrish 7/26/2010 14:16'!
renderTextInputTypeSelectionsFor: aRenderContext
	| callbackField optionsColl |
	optionsColl := #(#(#none #text #submit #checkbox #radio) #radio).
	callbackField := self
		storeValueCallback: [ :inputCellType | 
			(inputCellType notNil and: [ inputCellType notEmpty ])
				ifTrue: [ 
					self inputType: inputCellType.
					aSelector := #testTablePaginateFor:tableCellInputType: ] ]
		on: aRenderContext.
	((builder attributesMap)
		name: callbackField;
		parent) select: '' optionCNodes: optionsColl.
	((builder attributesMap)
		type: 'submit';
		value: 'submit';
		parent) input br! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:08'!
showSource

	| src |
	self flag: #todo.
	"create a div tag to Ajax render the source of the create method below.."

	builder h5: 'Source of the rendered method:'.	
	(aSelector beginsWith: #testTablePaginateFor:)
		ifTrue: [ src := (self class methodDict at: aSelector) asString string ]
		ifFalse: [ 
			src := (self testClass methodDict at: #setUp) asString string , '\\' withCRs
				, (self testClass methodDict at: aSelector) asString string ].
	builder
		attributes: #('style="color: darkblue ;font-family:''Times New Roman'';"');
		pre: src! !

!TestHtmlBuilder methodsFor: 'private' stamp: 'Skrish 7/14/2010 15:29'!
testClass

^HtmlBuilderTests! !

!TestHtmlBuilder methodsFor: 'create_html' stamp: 'Skrish 7/16/2010 16:53'!
testTablePaginateFor: aRenderContext

	self testTablePaginateFor: aRenderContext tableCellInputType: #none! !

!TestHtmlBuilder methodsFor: 'create_html' stamp: 'Skrish 7/26/2010 13:22'!
testTablePaginateFor: aRenderContext tableCellInputType: inputTextType

	|  rowsData |

 	rowsData := self generateTableData.

	builder defaultHtmlTable
		initPlugin: #Paginate;
                initPlugin: #HrefRows;
                visitPlugin: #hrefRowsAfter: withArguments:#(#( 'show' 'edit' 'del' ));
		renderContext: aRenderContext;
		tableAttributes: #('width="80%"');
		rowTextInputType: inputTextType;  "Modify this between: text, submit, radio, checkbox.. all of input types."
		headerOrientType: #top;
		headerCNode: #('ColumnField01' 'ColumnField02' 'ColumnField03' 'ColumnField04') rowsCNodes: rowsData.
   
! !

!TestHtmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 13:30'!
updateRoot: htmlRoot

self flag: #todo.
"handle the htmlRoot appropriate to MarkupBuilder here.."! !

!TestHtmlBuilder methodsFor: 'private' stamp: 'Skrish 7/26/2010 14:22'!
valuesTextAndSelectedDictionaryColl
	"can be as simple as below.. but for an elaborate example..with different text / value collection"

	"^OrderedCollection with: self builderTestsCreateSelectors with: aSelector."

	| aColl |
	aColl := OrderedCollection new.
	self builderTestsCreateSelectors
		do: [ :ea | 
			aColl
				add:
					((Dictionary new)
						at: #value put: ea asString;
						at: #text put: (ea asString copyReplaceAll: 'createMarkupBuilder' with: '');
						yourself).
			ea asString = aSelector
				ifTrue: [ aColl last at: #selected put: true ] ].
	^ aColl! !

TestHtmlBuilder subclass: #TestHtmlBuilderTableTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!TestHtmlBuilderTableTests class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/15/2010 14:20'!
initialize


WAAdmin register: self asApplicationAt: 'TestHtmlBuilderTableTests'  
! !

!TestHtmlBuilderTableTests methodsFor: 'create_table_csvfiles' stamp: 'Skrish 7/26/2010 13:50'!
csvFileFolderName
" Be able to render any selected Csv file from a given Folder.."

^'/media/OS/temp/csvfiles'
! !

!TestHtmlBuilderTableTests methodsFor: 'create_table_csvfiles' stamp: 'Skrish 7/26/2010 00:48'!
csvFilesFromFolder
	| aFileDirectory fileNames |
	aFileDirectory := FileDirectory default directoryNamed: self csvFileFolderName.
	[ fileNames := aFileDirectory fileNamesMatching: '*.csv' ]
		on: InvalidDirectoryError
		do: [ :ex | ^ MarkupBuilderError signalError: #csvFolderNotValid1 expandMacrosWithArguments: {(self csvFileFolderName)} ].
	^ fileNames! !

!TestHtmlBuilderTableTests methodsFor: 'create_html' stamp: 'Skrish 7/26/2010 00:48'!
getCsvFileName
	| fileNames |
	fileNames := self csvFilesFromFolder.
	csvFileName
		ifNil: [ 
			fileNames := self csvFilesFromFolder.
			csvFileName := fileNames notEmpty
				ifTrue: [ fileNames first ]
				ifFalse: [ ^ MarkupBuilderError signalError: #csvFilesNotFound1 expandMacrosWithArguments: {(self csvFileFolderName)} ] ].
	^ csvFileName! !

!TestHtmlBuilderTableTests methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:13'!
homeLinksFor: aRenderContext
	"links below the page to toggle between a test anchor/ home"

	builder hr.

	(builder attributesMap
		href: self class name;
		parent)
		a: 'Home:';
		br.
	(builder attributesMap
		href: 'TestHtmlBuilder';
		parent)
		a: 'TestHtmlBuilder';
		br.	
										
! !

!TestHtmlBuilderTableTests methodsFor: 'rendering' stamp: 'Skrish 7/16/2010 16:41'!
initializeBuilder: aRenderContext

		builder valueStream reset.
		builder styleScript: HtmlBuilderCss defaultTableCss.
		builder h4: 'Render any chosen csv file as a table'.
		self renderCsvFilesSelectFormFor: aRenderContext on: builder.! !

!TestHtmlBuilderTableTests methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:14'!
renderContentOn: html
	| aStream htmlB aRenderContext paginatePlugin |
	aRenderContext := html context.	"self halt."
	builder ifNil: [ builder := HtmlBuilder new ].
	[ 
	self initializeBuilder: aRenderContext.
	self renderTableFor: aRenderContext.
	self homeLinksFor: aRenderContext ] on: MarkupBuilderError do: [ :ex | self sendErrorText: ex description ].
	self showSource.
	self streamContentsFor:aRenderContext! !

!TestHtmlBuilderTableTests methodsFor: 'create_table_csvfiles' stamp: 'Skrish 7/24/2010 19:42'!
renderCsvFilesSelectFormFor: aRenderContext  on: aBuilder

	(aBuilder attributesMap
		action: aRenderContext actionUrl;
		method: 'post'; 
		parent)
		form: ''
		with: [
			self renderSelectFormFor: aRenderContext on: aBuilder].! !

!TestHtmlBuilderTableTests methodsFor: 'create_table_csvfiles' stamp: 'Skrish 7/26/2010 13:46'!
renderSelectFormFor: aRenderContext on: aBuilder
	| callbackField optionsColl valuesColl |
	valuesColl :=  self csvFilesFromFolder .
	optionsColl := OrderedCollection with: valuesColl with: csvFileName.
	callbackField := self
		storeValueCallback: [ :csvFile | 
			(valuesColl includes: csvFile)
				ifTrue: [ self csvFileName: csvFile ].
			aSelector := #testRenderCsvFilesFor: ]
		on: aRenderContext.
	((aBuilder attributesMap)
		name: callbackField;
		parent) select: '' optionCNodes: optionsColl.
	(((aBuilder attributesMap)
		type: 'submit';
		value: 'submit';
		parent) input)
		br;
		hr! !

!TestHtmlBuilderTableTests methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 00:48'!
renderTableFor: aRenderContext
	| paginatePlugin |
	paginatePlugin := builder defaultHtmlTable pluginInstance pluginRegistryAt: #Paginate.
	(paginatePlugin notNil and: [ paginatePlugin pluginBlockInvoked ])
		ifTrue: [ 
			builder defaultHtmlTable renderTable.	"just render the table for the currentPage set.."
			(builder defaultHtmlTable pluginInstance pluginRegistryAt: #Paginate) pluginBlockInvoked: false ]
		ifFalse: [ builder := self testRenderCsvFilesFor: aRenderContext ]! !

!TestHtmlBuilderTableTests methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:08'!
showSource
	"create a div tag to Ajax render the source of the create method below.."

	| src |
	builder h5: 'Source of the rendered method:'.
	src := (self class methodDict at: #tablePaginateFor:tableCellInputType:forCsvString:) asString string.
	builder
		attributes: #('style="color: darkblue ;font-family:''Times New Roman'';"');
		pre: src! !

!TestHtmlBuilderTableTests methodsFor: 'create_table_csvfiles' stamp: 'Skrish 7/26/2010 13:51'!
tablePaginateFor: aRenderContext tableCellInputType: textInputType forCsvString: csvFileStream
	| rowsData |
	(builder defaultHtmlTable)
		initPlugin: #Paginate;
		renderContext: aRenderContext;
		rowTextInputType: textInputType;
		csvReader: (TabOrCsvStreamReader new lineEnd: String cr);
		textInputTypeColl: #(#none); "Now handles type per column"
		fromCsvStream: csvFileStream headerRow: #topRow.	"Modify this between: text, submit, radio, checkbox.. all of input types."
	^ builder! !

!TestHtmlBuilderTableTests methodsFor: 'create_html' stamp: 'Skrish 7/26/2010 13:49'!
testRenderCsvFilesFor: aRenderContext
	" Be able to render any selected Csv file from a given Folder.."

	| csvFileStream returnVal |
	returnVal := self getCsvFileName .

	(csvFileStream := CrLfFileStream fileNamed: self csvFileFolderName , '/' , csvFileName)
		ifNil: [ ^MarkupBuilderError signalError: #csvFilesNotFound1 expandMacrosWithArguments:  {(self csvFileFolderName)} ].
	[ csvFileStream peek ifNil: [ self error: 'nil' ] ]
		on: Exception
		do: [ :ex | ^ MarkupBuilderError signalError: #csvFileNotValid1 expandMacrosWithArguments: {csvFileName} ].	"rare but possible 0 byte file situation or non existent file..etc"
			
	self tablePaginateFor: aRenderContext tableCellInputType: #none forCsvString: csvFileStream.
	^ builder! !

TestHtmlBuilder subclass: #TestXmlBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!TestXmlBuilder class methodsFor: 'init' stamp: 'Skrish 7/14/2010 15:22'!
initialize


WAAdmin register: self asApplicationAt: 'TestXmlBuilder'  
! !

!TestXmlBuilder methodsFor: 'private' stamp: 'Skrish 7/26/2010 14:28'!
displayXmlString
	| xmlBuilderTests xmlString xmlBuilder |
	xmlBuilderTests := XMLBuilderTests new xmlBuilder: XMLBuilder new.
	xmlString := self escapeHtmlChars: (xmlBuilderTests perform: aSelector) valueStream contents.
	(xmlBuilder := XMLBuilder new)
		attributes: #('style="color:darkred;font-family:''Times New Roman'';font-weight:bold;"');
				h5: 'XML Indented for easier readability...';
				pre: xmlString.
	^ xmlBuilder! !

!TestXmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:13'!
homeLinksFor: aRenderContext
	"links below the page to toggle between a test anchor/ home"

	builder hr.

	(builder attributesMap
		href: self class name;
		parent)
		a: 'Home: Random method';
		br.
	(builder attributesMap
		href: 'TestHtmlBuilder';
		parent)
		a: 'TestHtmlBuilder';
		br.
		
! !

!TestXmlBuilder methodsFor: 'rendering' stamp: 'Skrish 7/26/2010 14:14'!
renderContentOn: html
	| xmlBuilder aRenderContext |
	aRenderContext := html context.
	aSelector := self chooseSelector.
	html heading: aSelector level: 3.
	xmlBuilder := self displayXmlString.
	builder := HtmlBuilder new valueStream: xmlBuilder valueStream.
	self chooseSelectorFormFor: aRenderContext.
	self homeLinksFor: aRenderContext.
	self showSource.
	self streamContentsFor: aRenderContext.
	aSelector := nil! !

!TestXmlBuilder methodsFor: 'private' stamp: 'Skrish 7/14/2010 15:35'!
testClass

^XMLBuilderTests! !

WAComponent subclass: #SeasideTests
	instanceVariableNames: 'test test2 test3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!SeasideTests class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/13/2010 10:50'!
initialize
"self initialize"

WAAdmin register: self asApplicationAt: 'SeasideTests'  
! !

!SeasideTests methodsFor: 'as yet unclassified' stamp: 'Skrish 7/26/2010 00:45'!
renderContentOn: html
	html heading: 'asdasd' level: 3.	"self halt."
	html form
		with: [ 
			html textInput on: #test of: self.
			html textInput on: #test2 of: self.
			html textInput on: #test3 of: self.
			html submitButton ].
	html heading: 'asdasd' level: 3! !

!SeasideTests methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 10:56'!
test
	^ test! !

!SeasideTests methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 13:39'!
test2
	^ test2! !

!SeasideTests methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 14:11'!
test2: anObject


	test2 := anObject! !

!SeasideTests methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 14:11'!
test3
	^ test3! !

!SeasideTests methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 14:11'!
test3: anObject
	test3 := anObject! !

!SeasideTests methodsFor: 'accessing' stamp: 'Skrish 7/13/2010 14:11'!
test: anObject

	test := anObject! !

TestCase subclass: #MarkupBuilderMiscTests
	instanceVariableNames: 'instVar1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!MarkupBuilderMiscTests methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:42'!
checkThisUsingKeywordMethod: param1 with: param2
	^ param1 asString , ' : ' , param2 asString! !

!MarkupBuilderMiscTests methodsFor: 'private' stamp: 'Skrish 7/22/2010 10:26'!
checkThisUsingUnaryMethod

^'testUnaryMethodValue'! !

!MarkupBuilderMiscTests methodsFor: 'tests' stamp: 'Skrish 7/22/2010 19:26'!
setUp

instVar1 := 12323.! !

!MarkupBuilderMiscTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:42'!
testBlockAsArray
	| aColl aBlock |
	aBlock := [ 
	123 + 23.
	232 - 23 ].
	(aBlock respondsTo: #asArray)
		ifTrue: [ aColl := aBlock asArray ]
		ifFalse: [ aColl := MarkupUtility getInstance blockAsArray: aBlock ].
	self assert: aColl first = 146.
	self assert: aColl last = 209! !

!MarkupBuilderMiscTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:42'!
testBlockAsArrayForAssocs
	| aColl aBlock |
	aBlock := [ 
	'abc' -> 123.
	'def' -> 456.
	'efg' -> 789.
	'hij' -> 123.
	'klm' -> 456 ].
	(aBlock respondsTo: #asArray)
		ifTrue: [ aColl := aBlock asArray ]
		ifFalse: [ aColl := MarkupUtility getInstance blockAsArray: aBlock ].
	self assert: aColl size = 5.
	self assert: aColl first = ('abc' -> 123).
	self assert: (aColl at: 3) = ('efg' -> 789).
	self assert: aColl last = ('klm' -> 456)! !

!MarkupBuilderMiscTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:43'!
testBlockAsArrayKeywordMethod
	| aColl aBlock |
	aBlock := [ 
	self checkThisUsingKeywordMethod: 'abc' with: 'efg'.
	232 - 23 ].
	(aBlock respondsTo: #asArray)
		ifTrue: [ aColl := aBlock asArray ]
		ifFalse: [ aColl := MarkupUtility getInstance blockAsArray: aBlock ].
	self assert: aColl first = 'abc : efg'.
	self assert: aColl last = 209! !

!MarkupBuilderMiscTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:43'!
testBlockAsArrayUnaryMethod
	| aColl aBlock |
	aBlock := [ 
	self checkThisUsingUnaryMethod.
	232 - 23 ].
	(aBlock respondsTo: #asArray)
		ifTrue: [ aColl := aBlock asArray ]
		ifFalse: [ aColl := MarkupUtility getInstance blockAsArray: aBlock ].
	self assert: aColl first = 'testUnaryMethodValue'.
	self assert: aColl last = 209! !

!MarkupBuilderMiscTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:43'!
testMisc
	| aColl aVar1 |
	aVar1 := 'adad' -> 123.
	aColl := {(self checkThisUsingKeywordMethod: 'abc' with: 'efg').
	(232 - 23).
	aVar1.
	instVar1}.
	self assert: aColl size = 4! !

TestCase subclass: #MarkupBuilderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

MarkupBuilderTests subclass: #BuilderPluginTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!BuilderPluginTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:44'!
registerPlugin
	| htmlB |
	htmlB := HtmlBuilder new htmlTableAt: #test.
	htmlB initPlugin: #HrefRows.
	htmlB visitPlugin: #hrefRowsAfter: withArguments: #(nil).
	^ htmlB! !

!BuilderPluginTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:44'!
testForDummyPlugin
	| htmlB aParent anInst |
	htmlB := self registerPlugin.
	htmlB pluginInstance dummyPlugin: #HrefRows for: (HtmlBuilder new htmlTableAt: #test).
	anInst := htmlB pluginInstance pluginRegistry
		at: 'HtmlBuilderTableWidgetPluginHrefRows'
		ifAbsent: [ self assert: false ].
	self assert: anInst class name = #MarkupBuilderPluginDummy! !

!BuilderPluginTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:44'!
testForRegisterPlugin
	| htmlB |
	htmlB := self registerPlugin.
	htmlB pluginInstance pluginRegistry at: 'HtmlBuilderTableWidgetPluginHrefRows' ifAbsent: [ self assert: false ]! !

!BuilderPluginTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:44'!
testForReinitializePlugin
	| htmlB aParent anInst |
	htmlB := self registerPlugin.
	aParent := HtmlBuilder new htmlTableAt: #test.
	htmlB pluginInstance reinitializePlugin: #HrefRows for: aParent.
	anInst := htmlB pluginInstance pluginRegistry
		at: 'HtmlBuilderTableWidgetPluginHrefRows'
		ifAbsent: [ self assert: false ].
	self assert: anInst pluginParent = aParent! !

!BuilderPluginTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:44'!
testForRemovePlugin
	| htmlB |
	htmlB := self registerPlugin.
	htmlB pluginInstance removePlugin: #HrefRows forClass: #HtmlBuilderTableWidget.
	htmlB pluginInstance pluginRegistry at: 'HtmlBuilderTableTagPluginHrefRows' ifAbsent: [ ^ self ].
	self assert: false! !

MarkupBuilderTests subclass: #HtmlBuilderTests
	instanceVariableNames: 'htmlBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:01'!
createMarkupBuilderPaginateTable
	| rowsData |
	rowsData := OrderedCollection new.
	1 to: 67 do: [ :ea | rowsData add: (Array with: 'firstCell' with: ea) ].
	htmlBuilder h1: 'Testing Pagination'.
	(htmlBuilder defaultHtmlTable)
		initPlugin: #Paginate;
		tableAttributes: #('width="80%"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: rowsData.
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html' stamp: 'Skrish 7/22/2010 20:05'!
createMarkupBuilderSelectOptions
	|  selectOptionsValueAndTextColl |
	selectOptionsValueAndTextColl := OrderedCollection with: OrderedCollection new with: #().
	#('listItem1' 'listItem2')
		do: [ :ea | 
			selectOptionsValueAndTextColl first
				add:ea].
 
					htmlBuilder
						h1: 'select';
						select: ''  optionCNodes: selectOptionsValueAndTextColl .
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:18'!
createMarkupBuilderSimpleFormTableWithLinks
	htmlBuilder  styleScript: HtmlBuilderCss defaultTableCss;
					h2: 'Table Listing for: Sample Table'.
	(htmlBuilder defaultHtmlTable)
		initPlugin: #HrefRows;
		visitPlugin: #hrefRowsAfter: withArguments: #(#('show' 'edit' 'del'));
		tableAttributes: #('width="80%"' 'class="table_t1"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')).
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/26/2010 00:44'!
createMarkupBuilderSimpleHtml
	htmlBuilder h1: 'text'.
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:07'!
createMarkupBuilderSimplePaginateTable
	(htmlBuilder defaultHtmlTable)
		initPlugin: #Paginate;
		tableAttributes: #('width="80%"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')).
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html' stamp: 'Skrish 7/18/2010 23:41'!
createMarkupBuilderSimpleScript
	htmlBuilder script: 'function test(){alert("hi..!!");}';
		attributes: #('onclick="test();"' 'type="button"' 'value="click here"');
		input.
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:09'!
createMarkupBuilderSimpleTable
	(htmlBuilder defaultHtmlTable)
		tableAttributes: #('width="80%"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')).
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:10'!
createMarkupBuilderSimpleTableCheckbox
	(htmlBuilder defaultHtmlTable)
		rowTextInputType: #checkbox;
		tableAttributes: #('width="80%"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')).
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/18/2010 21:15'!
createMarkupBuilderSimpleTableEditable

	htmlBuilder  defaultHtmlTable rowTextInputType: #text;
					tableAttributes: #('width="80%"');
					headerCNode: #('ColumnField01' 'ColumnField02')
					rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')) .
	^htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:20'!
createMarkupBuilderSimpleTableFromPropertiesBean
	| beanColl bean |
	beanColl := OrderedCollection new.
	#(#(123 13 3123 323 'adad' 32) #(223 321 231 '323' 'asd' 32) #('asd' 123 3 3231 12 'asd'))
		do: [ :eaColl | 
			bean := PropertiesBean new initialize.
			eaColl doWithIndex: [ :eaValue :indx | bean elementAt: 'ColumnField_' , indx asString put: (eaColl at: indx) ].
			beanColl add: bean ].
	htmlBuilder styleScript: HtmlBuilderCss defaultTableCss.
	(htmlBuilder defaultHtmlTable)
		tableAttributes: #('width="80%"');
		fromPropertiesBeans: beanColl.
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:13'!
createMarkupBuilderSimpleTableHeaderLeft
	(htmlBuilder defaultHtmlTable)
		headerOrientType: #left;
		tableAttributes: #('width="80%"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')).
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/19/2010 00:21'!
createMarkupBuilderSimpleTableWithDefaultCss
	htmlBuilder styleScript: HtmlBuilderCss defaultTableCss.
	(htmlBuilder defaultHtmlTable)
		tableAttributes: #('width="80%"' 'class="table_t1"');
		headerCNode: #('ColumnField01' 'ColumnField02') rowsCNodes: #(#(123 32) #(223 32) #('asd' 'asd')).
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/23/2010 10:36'!
createMarkupBuilderTableFromCsv
	| csv |
	csv := 'ColumnField_1, ColumnField_2, ColumnField_3, ColumnField_4
	123, 13 , adad, 32
	13, 3123, adad, 32
	3123, 323, adad, 32'.
	htmlBuilder styleScript: HtmlBuilderCss defaultTableCss.
	(htmlBuilder htmlTableAt: #test)
		tableAttributes: #('width="80%"');
		csvReader: (TabOrCsvStreamReader new lineEnd: String cr);
		fromCsvStream: (ReadStream on: csv) headerRow: #topRow .
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html_table' stamp: 'Skrish 7/23/2010 11:45'!
createMarkupBuilderTableFromCsvWithFieldTypes
"The fields are rendered with different text input types as given in args to #textInputTypeColl: below"

	| csv |
	csv := 'ColumnField_1, ColumnField_2, ColumnField_3, ColumnField_4
	123, 13 , adad, 32
	13, 3123, adad, 32
	3123, 323, adad, 32'.
	htmlBuilder styleScript: HtmlBuilderCss defaultTableCss.
	(htmlBuilder htmlTableAt: #test)
		tableAttributes: #('width="80%"');
		csvReader: (TabOrCsvStreamReader new lineEnd: String cr);
		textInputTypeColl: #( none text submit checkbox);  "render the fields as per given types"
		fromCsvStream: (ReadStream on: csv) headerRow: #topRow .
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html' stamp: 'Skrish 7/14/2010 14:06'!
createMarkupBuilderW3OrgHtmlHead

	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				head: ''
				with: [ 
					htmlBuilder
						metaAttributes: #('CHARSET="UTF-8"');
						baseAttributes: #('HREF="http://www.example.com/"');
						title: 'An application with a long head';
						linkCssFile: 'default.css';
						linkCssFile: 'big.css' title: 'Big Text';
						attributes: #('SRC="support.js"');
						script: '';
						metaAttributes: #('NAME="APPLICATION-NAME"' 'CONTENT="Long headed application"') ].
			htmlBuilder h1: 'Head Meta Tags'.
			(htmlBuilder attributesMap style: 'color:red'; 
				parent) h5: 'Note: The links will not work back to localhost/seaside bcos of baseAttribute: setting. Go back or Refresh browser' ].
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'create_html' stamp: 'Skrish 7/18/2010 23:49'!
createMarkupBuilderW3OrgSample
	htmlBuilder
		h1: 'Sample page';
		p: 'This is a '
			with: [ 
					htmlBuilder
						attributes: #('href="TestHtmlBuilder"');
						a: 'simple';
						plainText: ' sample.';
						comment: 'this is a comment ' ].
	^ htmlBuilder! !

!HtmlBuilderTests methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 10:39'!
htmlBuilder: anObject
	htmlBuilder := anObject! !

!HtmlBuilderTests methodsFor: 'private' stamp: 'Skrish 7/7/2010 10:52'!
internalDiv: htmlB

htmlB h1: 'text'; br;
			attributes: #(' id="abc" style:"float:left; margin:0" ')  ;
			div:'Testing Welcome' 
			! !

!HtmlBuilderTests methodsFor: 'init' stamp: 'Skrish 7/14/2010 10:26'!
setUp

htmlBuilder := HtmlBuilder new! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:12'!
testMarkupBuilderHtmlWithMethodAsCNode
	| htmlB |
	htmlB := htmlBuilder html: '' with: [ htmlBuilder attributes: #('onLoad="1"'); body: '' with: [ self internalDiv: htmlBuilder ] ].
	self
		assert:
			(self
				string: htmlB valueString
				equivalentTo:
					'<html>
    <body onLoad="1">
        <h1>text</h1>
        <br />
        <div  id="abc" style:"float:left; margin:0" >Testing Welcome</div>
    </body>
</html>').
! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/26/2010 00:45'!
testMarkupBuilderPaginateTable
	| html |
	html := htmlBuilder
		docType: 'html';
		html: '' with: [ htmlBuilder body: '' with: [ self createMarkupBuilderPaginateTable ] ].
	self dumpToFile: html valueString.
	self
		assert:
			(html defaultHtmlTable pluginInstance pluginRegistry at: 'HtmlBuilderTableWidgetPluginPaginate') totalPages = 7! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:14'!
testMarkupBuilderSelectOptions
	| html |
	html := 	htmlBuilder
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [self createMarkupBuilderSelectOptions]].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <body>
        <h1>select</h1>
        <select>
            <option value="listItem1">listItem1</option>
            <option value="listItem2">listItem2</option>
        </select>
    </body>
</html>').
! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:12'!
testMarkupBuilderSimpleCssFiles
	| html |
	html := 	htmlBuilder html: '' with: [ htmlBuilder linkCssFileColl: #('test1.css' 'test2.css') . htmlBuilder  body: '' with: [ htmlBuilder h1: 'text' ] ].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <link REL="STYLESHEET" HREF="test1.css" />
    <link REL="STYLESHEET" HREF="test2.css" />
    <body>
        <h1>text</h1>
    </body>
</html>').
! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/25/2010 16:33'!
testMarkupBuilderSimpleFormTableWithLinks
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [ self createMarkupBuilderSimpleFormTableWithLinks]].
	self
		assert:
			(self
				string: html valueStringTrimmed
				equivalentTo:
					'<!!DOCTYPE html><html><body><style type="text/css">.table_t1 {border: 1px solid #888;}.thead_tr {color: white;background: #8888aa;halign: center;}.odd_tr {text-align: center; }.even_tr {background: #cccccc;text-align: center; }</style><h2>Table Listing for: Sample Table</h2><table width="80%" class="table_t1"><tr class="thead_tr"><th class=thead_th>ColumnField01</th><th class=thead_th>ColumnField02</th><th> </th><th> </th><th> </th></tr><tr class="odd_tr"><td class="trow_td">123</td><td class="trow_td">32</td><td> <a href="show_1">show</a></td><td> <a href="edit_1">edit</a></td><td> <a href="del_1">del</a></td></tr><tr class="even_tr"><td class="trow_td">223</td><td class="trow_td">32</td><td> <a href="show_2">show</a></td><td> <a href="edit_2">edit</a></td><td> <a href="del_2">del</a></td></tr><tr class="odd_tr"><td class="trow_td">asd</td><td class="trow_td">asd</td><td> <a href="show_3">show</a></td><td> <a href="edit_3">edit</a></td><td> <a href="del_3">del</a></td></tr></table></body></html>').! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:13'!
testMarkupBuilderSimpleHtml
	| html |
	html := 	htmlBuilder html: '' with: [ htmlBuilder attributes: #('onLoad="1"'); body: '' with: [htmlBuilder h1: 'text']].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <body onLoad="1">
        <h1>text</h1>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:13'!
testMarkupBuilderSimpleJsFiles
	| html |
	html := 	htmlBuilder html: '' with: [ htmlBuilder jsFileColl: #('test1.js' 'test2.js') . htmlBuilder  body: '' with: [ htmlBuilder h1: 'text' ] ].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <script SRC="test1.js" />
    <script SRC="test2.js" />
    <body>
        <h1>text</h1>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:13'!
testMarkupBuilderSimpleMetaRefresh
	| html |
	html := 	htmlBuilder html: '' with: [ htmlBuilder metaRefreshTime: 100 url: 'http://www.google.com'. htmlBuilder  body: '' with: [ htmlBuilder h1: 'text' ] ].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <meta http-equiv="Refresh" content="100; URL=http://www.google.com />
    <body>
        <h1>text</h1>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:44'!
testMarkupBuilderSimplePaginateTable
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [ self createMarkupBuilderSimplePaginateTable]]. 
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <body>
        <a href="link_nil">first</a>&nbsp;
        <a href="link_nil">prev</a>&nbsp;
        <a href="link_nil">1</a>&nbsp;
        <a href="link_nil">next</a>&nbsp;
        <a href="link_nil">last</a>&nbsp;
        <table width="80%">
            <tr class="thead_tr">
                <th class=thead_th>ColumnField01</th>
                <th class=thead_th>ColumnField02</th>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td">123</td>
                <td class="trow_td">32</td>
            </tr>
            <tr class="even_tr">
                <td class="trow_td">223</td>
                <td class="trow_td">32</td>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td">asd</td>
                <td class="trow_td">asd</td>
            </tr>
        </table>
        <a href="link_nil">first</a>&nbsp;
        <a href="link_nil">prev</a>&nbsp;
        <a href="link_nil">1</a>&nbsp;
        <a href="link_nil">next</a>&nbsp;
        <a href="link_nil">last</a>&nbsp;
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 10:32'!
testMarkupBuilderSimpleScript
	| html |
	html := 	htmlBuilder
		html: ''
		with: [ 
			htmlBuilder 
				body: ''
				with: [ self createMarkupBuilderSimpleScript]].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <body>
        <script type="text/javascript">function test(){alert("hi..!!");}</script>
        <input onclick="test();" type="button" value="click here" />
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:45'!
testMarkupBuilderSimpleTable
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [self createMarkupBuilderSimpleTable]].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <body>
        <table width="80%">
            <tr class="thead_tr">
                <th class=thead_th>ColumnField01</th>
                <th class=thead_th>ColumnField02</th>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td">123</td>
                <td class="trow_td">32</td>
            </tr>
            <tr class="even_tr">
                <td class="trow_td">223</td>
                <td class="trow_td">32</td>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td">asd</td>
                <td class="trow_td">asd</td>
            </tr>
        </table>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:45'!
testMarkupBuilderSimpleTableCheckbox
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [ self createMarkupBuilderSimpleTableCheckbox]].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <body>
        <table width="80%">
            <tr class="thead_tr">
                <th class=thead_th>ColumnField01</th>
                <th class=thead_th>ColumnField02</th>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td"> 
                    <input id="tr_1_td_1" type="checkbox" class="trow_td" multiple />123
                </td>
                <td class="trow_td"> 
                    <input id="tr_1_td_2" type="checkbox" class="trow_td" multiple />32
                </td>
            </tr>
            <tr class="even_tr">
                <td class="trow_td"> 
                    <input id="tr_2_td_1" type="checkbox" class="trow_td" multiple />223
                </td>
                <td class="trow_td"> 
                    <input id="tr_2_td_2" type="checkbox" class="trow_td" multiple />32
                </td>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td"> 
                    <input id="tr_3_td_1" type="checkbox" class="trow_td" multiple />asd
                </td>
                <td class="trow_td"> 
                    <input id="tr_3_td_2" type="checkbox" class="trow_td" multiple />asd
                </td>
            </tr>
        </table>
    </body>
</html>').
! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:46'!
testMarkupBuilderSimpleTableEditable
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [ self createMarkupBuilderSimpleTableEditable]]. 
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <body>
        <table width="80%">
            <tr class="thead_tr">
                <th class=thead_th>ColumnField01</th>
                <th class=thead_th>ColumnField02</th>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td"> 
                    <input id="tr_1_td_1" type="text" class="trow_td" multiple value="123" />
                </td>
                <td class="trow_td"> 
                    <input id="tr_1_td_2" type="text" class="trow_td" multiple value="32" />
                </td>
            </tr>
            <tr class="even_tr">
                <td class="trow_td"> 
                    <input id="tr_2_td_1" type="text" class="trow_td" multiple value="223" />
                </td>
                <td class="trow_td"> 
                    <input id="tr_2_td_2" type="text" class="trow_td" multiple value="32" />
                </td>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td"> 
                    <input id="tr_3_td_1" type="text" class="trow_td" multiple value="asd" />
                </td>
                <td class="trow_td"> 
                    <input id="tr_3_td_2" type="text" class="trow_td" multiple value="asd" />
                </td>
            </tr>
        </table>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:30'!
testMarkupBuilderSimpleTableFromPropertiesBean
	| html |
	html := 	htmlBuilder
		docType: 'html';
		html: ''
			with: [htmlBuilder 
						body: ''
						with: [ self createMarkupBuilderSimpleTableFromPropertiesBean]].
	self
		assert:
			(self
				string: html valueStringTrimmed
				equivalentTo:
					'<!!DOCTYPE html><html><body><style type="text/css">.table_t1 {border: 1px solid #888;}.thead_tr {color: white;background: #8888aa;halign: center;}.odd_tr {text-align: center; }.even_tr {background: #cccccc;text-align: center; }</style><table width="80%"><tr class="thead_tr"><th class=thead_th>ColumnField_1</th><th class=thead_th>ColumnField_2</th><th class=thead_th>ColumnField_3</th><th class=thead_th>ColumnField_4</th><th class=thead_th>ColumnField_5</th><th class=thead_th>ColumnField_6</th></tr><tr class="odd_tr"><td class="trow_td">123</td><td class="trow_td">13</td><td class="trow_td">3123</td><td class="trow_td">323</td><td class="trow_td">adad</td><td class="trow_td">32</td></tr><tr class="even_tr"><td class="trow_td">223</td><td class="trow_td">321</td><td class="trow_td">231</td><td class="trow_td">323</td><td class="trow_td">asd</td><td class="trow_td">32</td></tr><tr class="odd_tr"><td class="trow_td">asd</td><td class="trow_td">123</td><td class="trow_td">3</td><td class="trow_td">3231</td><td class="trow_td">12</td><td class="trow_td">asd</td></tr></table></body></html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:46'!
testMarkupBuilderSimpleTableHeaderLeft
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder
				body: ''
				with: [self createMarkupBuilderSimpleTableHeaderLeft]].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <body>
        <table width="80%">
            <tr class="trow_tr">
                <th class=thead_th>ColumnField01</th>
                <td class="trow_td">123</td>
                <td class="trow_td">223</td>
                <td class="trow_td">asd</td>
            </tr>
            <tr class="trow_tr">
                <th class=thead_th>ColumnField02</th>
                <td class="trow_td">32</td>
                <td class="trow_td">32</td>
                <td class="trow_td">asd</td>
            </tr>
        </table>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/19/2010 10:46'!
testMarkupBuilderSimpleTableWithDefaultCss
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [  
			htmlBuilder
				body: ''
				with: [ self createMarkupBuilderSimpleTableWithDefaultCss]].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <body>
        <style type="text/css">
.table_t1 {
border: 1px solid #888;
}
.thead_tr {
color: white;
background: #8888aa;
halign: center;
}
.odd_tr {
text-align: center; 
}
.even_tr {
background: #cccccc;
text-align: center; 
}</style>
        <table width="80%" class="table_t1">
            <tr class="thead_tr">
                <th class=thead_th>ColumnField01</th>
                <th class=thead_th>ColumnField02</th>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td">123</td>
                <td class="trow_td">32</td>
            </tr>
            <tr class="even_tr">
                <td class="trow_td">223</td>
                <td class="trow_td">32</td>
            </tr>
            <tr class="odd_tr">
                <td class="trow_td">asd</td>
                <td class="trow_td">asd</td>
            </tr>
        </table>
    </body>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/23/2010 05:26'!
testMarkupBuilderTableFromCsv
	| html |
	html := 	htmlBuilder
		docType: 'html';
		html: ''
			with: [htmlBuilder 
						body: ''
						with: [self createMarkupBuilderTableFromCsv]]. 
	self
		assert:
			(self
				string: html valueStringTrimmed
				equivalentTo:
					'<!!DOCTYPE html><html><body><style type="text/css">.table_t1 {border: 1px solid #888;}.thead_tr {color: white;background: #8888aa;halign: center;}.odd_tr {text-align: center; }.even_tr {background: #cccccc;text-align: center; }</style><table width="80%"><tr class="thead_tr"><th class=thead_th>ColumnField_1</th><th class=thead_th>ColumnField_2</th><th class=thead_th>ColumnField_3</th><th class=thead_th>ColumnField_4</th></tr><tr class="odd_tr"><td class="trow_td">123</td><td class="trow_td">13</td><td class="trow_td">adad</td><td class="trow_td">32</td></tr><tr class="even_tr"><td class="trow_td">13</td><td class="trow_td">3123</td><td class="trow_td">adad</td><td class="trow_td">32</td></tr><tr class="odd_tr"><td class="trow_td">3123</td><td class="trow_td">323</td><td class="trow_td">adad</td><td class="trow_td">32</td></tr></table></body></html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/23/2010 11:22'!
testMarkupBuilderTableFromCsvWithFieldTypes

	htmlBuilder xmlTrim: true;
		docType: 'html';
		html: ''
			with: [htmlBuilder
						body: ''
						with: [self createMarkupBuilderTableFromCsvWithFieldTypes]]. 
	self
		assert:
			(self
				string: htmlBuilder valueString
				equivalentTo:
					'<!!DOCTYPE html><html><body><style type="text/css">
.table_t1 {
border: 1px solid #888;
}
.thead_tr {
color: white;
background: #8888aa;
halign: center;
}
.odd_tr {
text-align: center; 
}
.even_tr {
background: #cccccc;
text-align: center; 
}</style><table width="80%"><tr class="thead_tr"><th class=thead_th>ColumnField_1</th><th class=thead_th>ColumnField_2</th><th class=thead_th>ColumnField_3</th><th class=thead_th>ColumnField_4</th></tr><tr class="odd_tr"><td class="trow_td">123</td><td class="trow_td"> <input id="tr_1_td_2" type="text" class="trow_td" multiple value="13" /></td><td class="trow_td"> <input id="tr_1_td_3" type="submit" class="trow_td" multiple value="adad" /></td><td class="trow_td"> <input id="tr_1_td_4" type="checkbox" class="trow_td" multiple />32</td></tr><tr class="even_tr"><td class="trow_td">13</td><td class="trow_td"> <input id="tr_2_td_2" type="text" class="trow_td" multiple value="3123" /></td><td class="trow_td"> <input id="tr_2_td_3" type="submit" class="trow_td" multiple value="adad" /></td><td class="trow_td"> <input id="tr_2_td_4" type="checkbox" class="trow_td" multiple />32</td></tr><tr class="odd_tr"><td class="trow_td">3123</td><td class="trow_td"> <input id="tr_3_td_2" type="text" class="trow_td" multiple value="323" /></td><td class="trow_td"> <input id="tr_3_td_3" type="submit" class="trow_td" multiple value="adad" /></td><td class="trow_td"> <input id="tr_3_td_4" type="checkbox" class="trow_td" multiple />32</td></tr></table></body></html>').! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:14'!
testMarkupBuilderW3OrgHtmlHead
	| html |
	html :=self createMarkupBuilderW3OrgHtmlHead.
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<!!DOCTYPE html>
<html>
    <head>
        <meta CHARSET="UTF-8" />
        <base HREF="http://www.example.com/" />
        <title>An application with a long head</title>
        <link REL="STYLESHEET" HREF="default.css" />
        <link REL="STYLESHEET" HREF="big.css" TITLE="Big Text" />
        <script SRC="support.js" type="text/javascript" />
        <meta NAME="APPLICATION-NAME" CONTENT="Long headed application" />
    </head>
    <h1>Head Meta Tags</h1>
    <h5 style="color:red">Note: The links will not work back to localhost/seaside bcos of baseAttribute: setting. Go back or Refresh browser</h5>
</html>').! !

!HtmlBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 10:39'!
testMarkupBuilderW3OrgSample
	| html |
	html := 	htmlBuilder docType: 'html';
		html: ''
		with: [ 
			htmlBuilder head: '' with: [ htmlBuilder title: 'Sample page' ];
				body: ''
				with: [ self createMarkupBuilderW3OrgSample]].
	self
		assert:
			(self
				string: html valueStringTrimmed
				equivalentTo:
					'<!!DOCTYPE html><html><head><title>Sample page</title></head><body><h1>Sample page</h1><p>This is a <a href="TestHtmlBuilder">simple</a> sample.<!!-- this is a comment --></p></body></html>').! !

!HtmlBuilderTests methodsFor: 'tests-table' stamp: 'Skrish 7/23/2010 10:26'!
testRowsCollFromCsv

	| table csvString anArray |
	csvString := '"sno","title","location","summary","importance rating","Date Last Reviewed","Status of Review"
12,"Training docs and Excercises","{ditto from above }/training","Various presentations by the Director ( Jim Long)
* Database The excercises will be the basis of our 
LoanIQ Certification process going forward","I","Aug 20th 2009","Second basic pass"
31,"Project-StartUp for implementation,
 in a new Host Bank","smb://nyloaniq01/q/Documents/ProfessionalServices/,Implementation%20Documentation/Project Start-Up","Loan IQ sample project plan.xls",,,
1,2,3,4,5,6,7
13,"Build Docs","ditto from above ls2Build","\u2013",,,'. "- : \u2013 is typical wide char that balks the browser.."
	table := HtmlBuilderTableWidget basicNew.
	anArray := table readCsvToHeaderAndRowsCollection: csvString readStream .
	self assert: anArray size equals: 2.
	self assert: anArray first size equals: 7.
	self assert: anArray last first size equals: 7.
	self assert: anArray last size equals: 4.
	self assert: anArray last last size equals: 7.				! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 6/27/2010 23:47'!
canOpenDiffMorph

^false! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 7/6/2010 19:33'!
dumpToFile

^false! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:43'!
dumpToFile: aString
	| aFs |
	aFs := FileStream concreteStream.
	[ 
	aFs := aFs forceNewFileNamed: '/media/OS/temp/test.html'.
	aFs nextPutAll: aString ] ensure: [ aFs close ]! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 6/27/2010 23:56'!
openDiffMorph: aStr1 with: aStr2
	self canOpenDiffMorph
		ifTrue: [ 
			(DiffMorph from: aStr1 to: aStr2) openInWindowLabeled: 'MarkupBuilderTests'.
			self halt	"ensure it opens 1 window at a time..!! when run from TestRunner" ]! !

!MarkupBuilderTests methodsFor: 'comment' stamp: 'Skrish 7/26/2010 00:43'!
possibleSyntaxAlternatives
	"This was the initial scratch pad.. retaining it as a the trail of thought on markup api...creation..
Currently only 3, 3b, 3c are implemented.. and seem to be the best alternative"

	| newBldr |
	newBldr := XMLBuilder new.	"1 all as proper message/ arguments"
	newBldr
		attributes: #('a=1' 'b=2');
		tag: 'rootTag'
			text: 'text'
			with: [ 
					newBldr
						attributes: #();
						tag: 'newC' text: '' with: nil ].	"2 lil optimization  variable size 1..3 array of args and cNode as blk"
	newBldr
		tagContents: #('rootTag' #('a=1' 'b=2') 'text')
		with: [ 
			| tagCArr |
			tagCArr := Array with: 'newC' with: #() with: ''.	"or a helper method viz: newBldr nodeTag:attr:text: to return the array"
			newBldr tagContents: tagCArr with: nil ].	"3 nodeTag as a message prefix and runtime evaluation of the method to call. note the quoted attribs"
	newBldr
		attributes: #('a="1"' 'b="2"');
		rootTag: 'text'
			with: [ 
					newBldr
						attributes: #();
						newC ].	"3b A variant to account for islands of xml/ markup string inserted"
	newBldr
		attributes: (Array with: 'a' -> 1 with: 'b' -> 2);
		rootTag: 'text'
			with: [ 
					'<newC>
				</newC>' ].	"3c. Attributes also markup streamed.."
	((newBldr attributesMap)
		a: 1;
		b: 2;
		parent) rootTag: 'text' with: [ newBldr newC ].	"4 nodeTag as a message prefix and all other values as variable array 1..3 size complete runtime eval.."
	newBldr rootTag: (Array with: 'text' with: #('a=1' 'b=2') with: [ newBldr newC: (Array with: '' with: #() with: nil) ]).	"5 pure groovy/ ruby like markup string to be parsed by markup builder.."
	newBldr
		mkUp:
			'rootTag("text" a:1 b:2) {  
							newC()  }'.	"All of them producing the following xml"
	'<rootTag a="1" b="2">text
    <newC>
    </newC>
</rootTag>'! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 7/19/2010 10:58'!
strictMatch

^true! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 6/27/2010 23:49'!
string: aString equivalentTo: anotherString
	"find if the strings match once the tag indents are stripped.."

	| aBool aStr1 aStr2 |
	self dumpToFile
		ifTrue: [ self dumpToFile: aString ].
	self strictMatch
		ifTrue: [ aBool := (aStr1 := aString) = (aStr2 := anotherString) ]
		ifFalse: [ aBool := (aStr1 := self stripNodeTagSpaces: aString) asArray = (aStr2 := self stripNodeTagSpaces: anotherString) asArray ].
	aBool
		ifFalse: [ self openDiffMorph: aStr1 with: aStr2 ].
	^ aBool! !

!MarkupBuilderTests methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:44'!
stripNodeTagSpaces: xmlString
	"comment: pacManEatNodeTagSpaces will eat extra spaces within tags incl inside attrib string..!! helper to assert tests..simplistically rather than xmlEquals using XMLDomParser.."

	"self  new stripNodeTagSpaces: '<tagRoot abc=''sd''     xyz =''dsd''   > dsd ddd  
	<root>3424 sdf fd
	</root> sadasd
	   </tagRoot   >'"

	| xmlStream newXmlStream nextChar peek spaceFlag spacesStr |
	xmlStream := ReadStream on: xmlString.
	newXmlStream := WriteStream on: ''.
	xmlStream skipTo: $<.
	newXmlStream nextPut: $<.
	spacesStr := String
		with: Character space
		with: Character cr
		with: Character lf
		with: Character tab.
	[ xmlStream atEnd ]
		whileFalse: [ 
			nextChar := xmlStream next.
			peek := xmlStream peek.
			(spacesStr includes: peek)
				ifFalse: [ newXmlStream nextPut: nextChar ]
				ifTrue: [ 
					newXmlStream nextPut: nextChar.
					peek = Character space
						ifTrue: [ newXmlStream nextPut: Character space ].
					[ spacesStr includes: peek ]
						whileTrue: [ 
							xmlStream next.
							peek := xmlStream peek ] ] ].
	^ newXmlStream contents! !

!MarkupBuilderTests methodsFor: 'comment' stamp: 'Skrish 7/14/2010 14:01'!
todolist

"
*	Forms component
	Table extension is more properly finished and completely usable
	Table creation from csv and db table
	JSON/ Ini and other markup builders
	Visit / review Html convinience method extensions for style/ the eight attributes of any form tag viz: onchange/ onenter/ onexit etc...
	HrefPlugin needs to include seaside renderContext for proper href links..
	Review the DNU usage especially for plugin..currently a tad uncomfortable with how/ what I do there..perhaps lazy block execution with checks may help...
	Ajax/ Jquery any other extensions...
	Plugin framework is important: make it work so that it can attract 100's of others to try extending it..
	
	Review and check on base xml..capabilities..
	Time Profiling.. integrate basic time count against Seaside style rendering..
	Space Profiling: calculate the mem space used..? prefer a graph through an execution cycle..
	
	
	
	ps: I must say Pharo is really cool.. rather productive since I have touched it.. !! Hope I can work on:
	 * DBMS standardized.. JDBC like support not the squeakDBX type..
	 * WebServices full n complete..
	 * CogIt VM/ VM Maker.. 
	 * A Groovy/ Java bridge.. JNIPort to be evaluated first..as simple/ easy as in JRuby if possible..call it JPharo.. run interchangeably on JVM/ CogVM..
	 * Ruby/ Python /Groovy cool features be integrated in so far as possible viz: from simple stuff like csv , pdf read/write; easy enterprise support ; 
	 * MS windows world of COM/ Dlls/ ActiveX/ Registry/ etc.. like groovy scriptom etc..
	 * IPad like device..!!.. integration..
"! !

MarkupBuilderTests subclass: #PropertiesBeanTests
	instanceVariableNames: 'aSimpleBean'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!PropertiesBeanTests methodsFor: 'accessing' stamp: 'Skrish 7/15/2010 10:05'!
aSimpleBean: anObject
	aSimpleBean := anObject! !

!PropertiesBeanTests methodsFor: 'create_bean' stamp: 'Skrish 7/23/2010 03:46'!
createMarkupBuilderSimpleBean

	aSimpleBean beanAlias: 'PropertiesBean'.
	aSimpleBean text: 'TopRoot'.
	aSimpleBean elementProperties addAll: {#root->123. #child1->123}.
	^aSimpleBean! !

!PropertiesBeanTests methodsFor: 'create_bean' stamp: 'Skrish 7/23/2010 03:56'!
createMarkupBuilderSimpleBeanUptoGrandCNode

	|  child1 gChild1 attrDict |
	aSimpleBean text: 'TopRoot'.
	aSimpleBean attributeProperties addAll: {'abc'->32. 'xyz'->23 }.
	child1 := TrialChild new.
	child1 text: 'Child1'.
	child1 attributeProperties add: 'abcd="434" xyz1="232"'.
	gChild1 := TrialChild new beanAlias: 'TrialGrandChild1'.
	gChild1 text: 'GrandChild1'.
	gChild1 attributeProperties addAll: {'abcd'->434. 'xyz1'->232}.
	child1 elementProperties addAll: { #childRoot->234. gChild1}.
	aSimpleBean elementProperties addAll: {#root->123. child1}.
	^aSimpleBean! !

!PropertiesBeanTests methodsFor: 'create_bean' stamp: 'Skrish 7/23/2010 03:52'!
createMarkupBuilderSimpleBeanWithAlias

	aSimpleBean beanAlias: 'Hardik'.
	aSimpleBean text: 'TopRoot'.
	aSimpleBean elementProperties addAll: {#root->123. #child1->123}.
	^aSimpleBean! !

!PropertiesBeanTests methodsFor: 'create_bean' stamp: 'Skrish 7/23/2010 03:48'!
createMarkupBuilderSimpleBeanWithAttribs

	aSimpleBean text: 'TopRoot'.
	aSimpleBean attributeProperties addAll: {  'abc'->32. 'xyz'->23}.
	aSimpleBean elementProperties addAll: {#root->123. #child1->123}.
	^aSimpleBean! !

!PropertiesBeanTests methodsFor: 'create_bean' stamp: 'Skrish 7/23/2010 03:59'!
createMarkupBuilderSimpleBeanWithCNode
" shows the variants in adding attributes and elements "
	| child1 |
	aSimpleBean beanAlias: 'PropertiesBean'.
	aSimpleBean text: 'TopRoot'.
	aSimpleBean attributeAt: 'abc' put: 32; "1. add to attributes or elements through ..At: put:"
			attributeAt:'xyz' put:23.
	child1 := PropertiesBean new.
	child1 text: 'Child1'.
	child1 attributeProperties addAll: {'abcd'->434. 'xyz1'->232 }. "2. add through literal array of assocs"
	(aSimpleBean elementProperties) "3. add each assoc"
		add: #root -> 123;
		add: child1.
	^aSimpleBean! !

!PropertiesBeanTests methodsFor: 'create_bean' stamp: 'Skrish 7/15/2010 10:00'!
setUp


	aSimpleBean := Trial new.! !

!PropertiesBeanTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:08'!
testCreateSimpleBean

	aSimpleBean := self createMarkupBuilderSimpleBean.
	self
		assert:
			(self
				string: (aSimpleBean xmlStringTrimmed: true)
				equivalentTo: '<?xml version="1.0" ?><PropertiesBean>TopRoot<root>123</root><child1>123</child1></PropertiesBean>')! !

!PropertiesBeanTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:10'!
testCreateSimpleBeanUptoGrandCNode

	aSimpleBean := self createMarkupBuilderSimpleBeanUptoGrandCNode.
	self
		assert:
			(self
				string: (aSimpleBean xmlStringTrimmed: true)
				equivalentTo:
					'<?xml version="1.0" ?><Trial abc="32" xyz="23">TopRoot<root>123</root><TrialChild abcd="434" xyz1="232">Child1<childRoot>234</childRoot><TrialGrandChild1 abcd="434" xyz1="232">GrandChild1</TrialGrandChild1></TrialChild></Trial>')! !

!PropertiesBeanTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:06'!
testCreateSimpleBeanWithAlias

	aSimpleBean := self createMarkupBuilderSimpleBeanWithAlias.
	self
		assert:
			(self
				string: (aSimpleBean xmlStringTrimmed: true)
				equivalentTo: '<?xml version="1.0" ?><Hardik>TopRoot<root>123</root><child1>123</child1></Hardik>')! !

!PropertiesBeanTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:11'!
testCreateSimpleBeanWithAttribs

	aSimpleBean :=self createMarkupBuilderSimpleBeanWithAttribs.
	self
		assert:
			(self
				string: (aSimpleBean xmlStringTrimmed: true)
				equivalentTo: '<?xml version="1.0" ?><Trial abc="32" xyz="23">TopRoot<root>123</root><child1>123</child1></Trial>')! !

!PropertiesBeanTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:11'!
testCreateSimpleBeanWithCNode

	aSimpleBean := self createMarkupBuilderSimpleBeanWithCNode.
	self
		assert:
			(self
				string: (aSimpleBean xmlStringTrimmed: true)
				equivalentTo:
					'<?xml version="1.0" ?><PropertiesBean abc="32" xyz="23">TopRoot<root>123</root><PropertiesBean abcd="434" xyz1="232">Child1</PropertiesBean></PropertiesBean>')! !

MarkupBuilderTests subclass: #XMLBuilderTests
	instanceVariableNames: 'xmlBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

!XMLBuilderTests methodsFor: 'create_xml' stamp: 'Skrish 7/22/2010 20:13'!
createMarkupBuilderBasicXMLTrimmed

	xmlBuilder xmlPreprocessor;
		attributes: {'a'->6. 'b="7"'};
		test: ''
		with: [ 
			xmlBuilder attributes: #('a="1"' 'b="2"');
				trial: '';
				attributes: #('a="3"' 'b="4"');
				trial: '' ;
				trial ].
	^xmlBuilder! !

!XMLBuilderTests methodsFor: 'create_xml' stamp: 'Skrish 7/18/2010 22:34'!
createMarkupBuilderBasicXMLWithCascadedNodes

"	self setUp."
	xmlBuilder := XMLBuilder new.
	xmlBuilder xmlPreprocessor;
		attributes: #('a="6"' 'b="7"');
		test: ''
		with: [ 
			xmlBuilder
				attributes: #('a="1"' 'b="2"');
				trial: '';
				attributes: #('a="3"' 'b="4"'); 
				trial: '';
				trial ].
	^xmlBuilder! !

!XMLBuilderTests methodsFor: 'create_xml' stamp: 'Skrish 7/14/2010 15:41'!
createMarkupBuilderBasicXMLWithNS

	xmlBuilder
		currentNsPrefix: 'myns';
		xmlPreprocessor.
	(xmlBuilder attributesMap
		a: 6;	b: 7;
		parent)
		xmlnsPrefix: 'myns' nsUrl: 'http://www.w3.org/myns';
		test: ''
			with: [ (xmlBuilder attributesMap
						a: 1;	b: 2;
						parent) trial: ''.
					(xmlBuilder attributesMap
						a: 3; b: 4;
						parent)
						trial: '';
						trial ].
	^ xmlBuilder! !

!XMLBuilderTests methodsFor: 'create_xml' stamp: 'Skrish 7/14/2010 14:27'!
createMarkupBuilderXMLWithMutipleNS

	xmlBuilder currentNsPrefix:  'myns';
	    xmlPreprocessor;
	   xmlnsPrefix: 'myns' nsUrl: 'http://www.w3.org/myns';
	   xmlnsPrefix: 'h' nsUrl: 'http://www.w3.org/html5';
		test: ''
		with: [ 
			xmlBuilder copy attributes: #('a="1"' 'b="2"');
				currentNsPrefix: 'h';
				trial; 
				attributes: #('a="3"' 'b="4"');
				trial.
			xmlBuilder copy currentNsPrefix: 'myns';
				trial  ].
	^xmlBuilder! !

!XMLBuilderTests methodsFor: 'init' stamp: 'Skrish 7/14/2010 14:27'!
setUp


	xmlBuilder := XMLBuilder new .! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/26/2010 00:45'!
testCodeCritic
	| aColl |
	aColl := OrderedCollection new.
	aColl addAll: #(123 323 2323).
	self assert: (aColl at: 1) equals: 123! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 10:59'!
testMarkupBuilderBasicXML
	| newBldr aStr |
	newBldr := XMLBuilder new.
	newBldr attributes: #('a="1" b="2"');test: 'text'.
	self
		assert:
			(self
				string: newBldr valueString
				equivalentTo:
					'<test a="1" b="2">text</test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 10:56'!
testMarkupBuilderBasicXMLTrimmed
	| newBldr  |
	xmlBuilder xmlTrim: true.
	newBldr := self createMarkupBuilderBasicXMLTrimmed.
	self
		assert:
			(self
				string: newBldr valueString
				equivalentTo:
					'<?xml version="1.0" ?><test a="6" b="7"><trial a="1" b="2" /><trial a="3" b="4" /><trial /></test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:00'!
testMarkupBuilderBasicXMLWithCNodeAndAttribs
	| newBldr aStr |
	newBldr := XMLBuilder new.
	newBldr attributes: #('a="6"' 'b="7"');test: '' with: [ newBldr attributes: #('a="1"' 'b="2"') ; trial: '' ].
	self
		assert:
			(self
				string: newBldr valueString
				equivalentTo:
					'<test a="6" b="7">
    <trial a="1" b="2" />
</test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 10:56'!
testMarkupBuilderBasicXMLWithCascadedNodes

	xmlBuilder := self createMarkupBuilderBasicXMLWithCascadedNodes.
	self
		assert:
			(self
				string: xmlBuilder valueString
				equivalentTo:
					'<?xml version="1.0" ?>
<test a="6" b="7">
    <trial a="1" b="2" />
    <trial a="3" b="4" />
    <trial />
</test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:02'!
testMarkupBuilderBasicXMLWithChildNode
	| newBldr aStr |
	newBldr := XMLBuilder new.
	newBldr test: '' with: [ newBldr attributes: #('a="1"' 'b="2"'); trial: ''  ].
	self
		assert:
			(self
				string: newBldr valueString
				equivalentTo:
					'<test>
    <trial a="1" b="2" />
</test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 10:57'!
testMarkupBuilderBasicXMLWithNS
	
	xmlBuilder xmlTrim: true. 
	xmlBuilder := self createMarkupBuilderBasicXMLWithNS.
	self
		assert:
			(self
				string: xmlBuilder valueString
				equivalentTo:
				'<?xml version="1.0" ?><myns:test a="6" b="7" xmlns:myns="http://www.w3.org/myns"><myns:trial a="1" b="2" /><myns:trial a="3" b="4" /><myns:trial /></myns:test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:02'!
testMarkupBuilderBasicXMLWithXmlDecl
	| newBldr aStr |
	newBldr := XMLBuilder new .
	newBldr xmlPreprocessor; attributes: #('a="6"' 'b="7"') ;test: '' with: [ newBldr attributes: #('a="1"' 'b="2"'); trial: '' ].
	self
		assert:
			(self
				string: newBldr valueString
				equivalentTo:
					'<?xml version="1.0" ?>
<test a="6" b="7">
    <trial a="1" b="2" />
</test>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/7/2010 10:58'!
testMarkupBuilderForInvalidCNodeArg
	| htmlB exStr |
	htmlB := XMLBuilder new.
	[ htmlB html: '' with: [ htmlB attributes: #('onLoad="1"') ; body: '' with: 'Error being raised here..' ] ]
		on: MarkupBuilderError
		do: [ :ex | exStr := ex description ].
	self assert: exStr = ('MarkupBuilderError: ',(MarkupBuilderError errorTextDictionary at: #cNodeNotBlockType))! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/7/2010 11:01'!
testMarkupBuilderForInvalidMultipleArgs
	| htmlB exStr |
	htmlB := XMLBuilder new.
	[ 
	htmlB
		html: ''
		with: [ 
			htmlB 
				attributes: #('onLoad="1"');
				body: ''
				with: [ 'Error being raised here..' ]
				with: [ '2 args not allowed' ] ] ] on: MarkupBuilderError do: [ :ex | exStr := ex description ].
	self assert: exStr = ('MarkupBuilderError: ',(MarkupBuilderError errorTextDictionary at: #bldrMaxArgs))! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/7/2010 10:59'!
testMarkupBuilderForInvalidSelectors
	| htmlB exStr |
	htmlB := XMLBuilder new.
	[ htmlB html: '' someNode: [ htmlB body: 123 with: '' ] ] on: MarkupBuilderError do: [ :ex | exStr := ex description ].
	self assert: exStr = ('MarkupBuilderError: ',(MarkupBuilderError errorTextDictionary at: #bldrAllowedArgs))! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:01'!
testMarkupBuilderNodeWithTextAndAttribs01
	| html |
	html := XMLBuilder new.
	html html: '' with: [ html attributes: #('onLoad="1"') ; body: '' with: [ html attributes: #('a="3"');h1: 'text'  ] ].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <body onLoad="1">
        <h1 a="3">text</h1>
    </body>
</html>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/19/2010 11:02'!
testMarkupBuilderSimpleHtml
	| html |
	html := XMLBuilder new.
	html html: '' with: [ html attributes: #('onLoad="1"'); body: '' with: [ html  attributes: #() ; h1: 'text'] ].
	self
		assert:
			(self
				string: html valueString
				equivalentTo:
					'<html>
    <body onLoad="1">
        <h1>text</h1>
    </body>
</html>')! !

!XMLBuilderTests methodsFor: 'tests' stamp: 'Skrish 7/18/2010 23:22'!
testMarkupBuilderXMLWithMutipleNS

	xmlBuilder := self createMarkupBuilderXMLWithMutipleNS.
	self
		assert:
			(self
				string: xmlBuilder valueStringTrimmed
				equivalentTo:
				'<?xml version="1.0" ?><myns:test xmlns:myns="http://www.w3.org/myns" xmlns:h="http://www.w3.org/html5"><h:trial a="1" b="2" /><h:trial a="3" b="4" /><myns:trial /></myns:test>')! !

!XMLBuilderTests methodsFor: 'accessing' stamp: 'Skrish 7/18/2010 22:28'!
xmlBuilder
	
^xmlBuilder! !

!XMLBuilderTests methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 14:33'!
xmlBuilder: anObject
	xmlBuilder := anObject! !

Object subclass: #MarkupAttributesMapBuilder
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

!MarkupAttributesMapBuilder methodsFor: 'handle_markup' stamp: 'Skrish 7/13/2010 18:43'!
doesNotUnderstand: aMessage
	"The default method to handle all tags and their values. aMessage is as if that message is sent for action..but converts to a text builder. Sheer non OO practice.. !!"

	| aSelector args |

	aSelector := aMessage selector.
	args := aMessage arguments asOrderedCollection.
	self key: (aSelector subStrings: ':') first value: args first.
! !

!MarkupAttributesMapBuilder methodsFor: 'init                                                           ' stamp: 'Skrish 7/26/2010 00:32'!
initialize: aParent
	parent := aParent! !

!MarkupAttributesMapBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:32'!
key: aKey value: aText
	parent attributes add: aKey -> aText! !

!MarkupAttributesMapBuilder methodsFor: 'accessor' stamp: 'Skrish 7/13/2010 18:38'!
parent

^parent! !

!MarkupAttributesMapBuilder methodsFor: 'accessor' stamp: 'Skrish 7/13/2010 18:38'!
valueStream

^parent valueStream! !

Object subclass: #MarkupBuilder
	instanceVariableNames: 'valueStream indent validator attributes utilityClassInstance pluginInstance'
	classVariableNames: 'subclassDict'
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

MarkupBuilder subclass: #IniBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Others'!

!IniBuilder class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/5/2010 19:17'!
classInfo1

"
Ref:http://en.wikipedia.org/wiki/INI_file

basic adaptation:
[section]
 key=value

probably easily mapped to nodeTag>>attribArray.. of single depth only..


"! !

IniBuilder subclass: #PropertiesBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Others'!

!PropertiesBuilder class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/9/2010 13:12'!
classInfo1

"
Ref: http://en.wikipedia.org/wiki/.properties
Simpler than ini file.. no sections so just one node and attribsArray..+ comments..
"! !

MarkupBuilder subclass: #JSONBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Others'!

!JSONBuilder class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/5/2010 19:17'!
classInfo1
"
Ref: http://www.json.org/ ; http://en.wikipedia.org/wiki/JSON
{
    'glossary': {
        'title': 'example glossary',
		'GlossDiv': {
            'title': 'S',
			'GlossList': {
                'GlossEntry': {
                    'ID': 'SGML',
					'SortAs': 'SGML',
					'GlossTerm': 'Standard Generalized Markup Language',
					'Acronym': 'SGML',
					'Abbrev': 'ISO 8879:1986',
					'GlossDef': {
                        'para': 'A meta-markup language, used to create markup languages such as DocBook.',
						'GlossSeeAlso': ['GML', 'XML']
                    },
					'GlossSee': 'markup'
                }
            }
        }
    }
}
"! !

!MarkupBuilder class methodsFor: 'comment' stamp: 'Skrish 6/28/2010 00:47'!
classInfo

 ^'
Ref: Groovy MarkupBuilder.. as the motivation alongside lack of easy extensibility in seaside html construction..

@author:
Skrish

@date-modified: 28 June 2010;19 June 2010

@usage-API:
{None}

@Class:
Abstract, not to be instantiated.
Can be used as AbstractFactory through newFor: symb method..

@instVars:
indent: the indent level of the node
valueStream: markup write stream
validator: the singleton instance of MarkupValidator 
utilClassInst: the singleton instance of MarkupUtility valueStream:
mbAttr:
pluginRegistry:


@classVars:
subclassDict: collection of the instantiation of MarkupBuilder.
 
@classInstVars:





@instMethods:
Abstract subclass responsibility methods only

@classMethods:
newFor: abstract factory method to return specific builder class instantiated.. 

'! !

!MarkupBuilder class methodsFor: 'instance creation' stamp: 'Skrish 6/18/2010 09:28'!
new
"use subclasses for specific markup utility"
self shouldNotImplement ! !

!MarkupBuilder class methodsFor: 'instance creation' stamp: 'Skrish 6/21/2010 12:55'!
newFor: markupSymbol
" self newFor: #Html" 
 | markupBldr |
 markupBldr := (self subclassDict at: markupSymbol) new.
 markupBldr initialize.
 ^markupBldr! !

!MarkupBuilder class methodsFor: 'private' stamp: 'Skrish 6/21/2010 12:54'!
subclassDict

| subclassColl |
subclassColl  := self allSubclasses.
(subclassDict notNil and: [ subclassDict size = subclassColl size]) 
	ifTrue: [ ^subclassDict].
	
subclassDict := Dictionary new.
subclassColl collect: [ :ea | subclassDict at: ( ea name asString copyReplaceAll:  'Builder' with: '') asSymbol put: ea].

^subclassDict.! !

!MarkupBuilder methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/7/2010 14:31'!
attributes
	attributes ifNil: [ attributes := OrderedCollection new ].
	attributes isSequenceable
		ifFalse: [ ^ attributes := attributes asOrderedCollection ].
	^ attributes! !

!MarkupBuilder methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 00:33'!
attributes: anAttribCollection
	self attributes
		ifEmpty: [ 
			attributes := anAttribCollection asOrderedCollection.
			^ self ].
	MarkupBuilderError signalError: #attributesNotNil! !

!MarkupBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:33'!
attributesMap
	^ MarkupAttributesMapBuilder basicNew initialize: self! !

!MarkupBuilder methodsFor: 'subclassResponsibility' stamp: 'Skrish 7/26/2010 00:33'!
closeTag: aTag with: blkNode
	self subclassResponsibility! !

!MarkupBuilder methodsFor: 'subclassResponsibility' stamp: 'Skrish 7/26/2010 00:33'!
createTag: aTag text: aText with: blkNode
	"should implement in subclass using mbAttr attribColl also.."

	self subclassResponsibility! !

!MarkupBuilder methodsFor: 'handle_markup' stamp: 'Skrish 7/16/2010 15:59'!
doesNotUnderstand: aMessage
	"The default method to handle all tags and their values. aMessage is as if that message is sent for action..but converts to a text builder. Sheer non OO practice.. !!"

	| aSelector args |
	aSelector := aMessage selector.
	args := aMessage arguments asOrderedCollection.
	validator validateForBuilder: args with: aSelector.
	self modifyArgs: args for: aSelector.
	self toggleMethodCreationFor: args.
! !

!MarkupBuilder methodsFor: 'subclassResponsibility' stamp: 'Skrish 7/26/2010 00:33'!
handleBlock: aTag with: blkNode
	self subclassResponsibility! !

!MarkupBuilder methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 00:33'!
indent
	indent ifNil: [ indent := 0 ].
	^ indent! !

!MarkupBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:33'!
indent: anIndent
	indent := anIndent! !

!MarkupBuilder methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:33'!
indentSpaces
	self subclassResponsibility! !

!MarkupBuilder methodsFor: 'private' stamp: 'Skrish 7/25/2010 09:50'!
initPlugin: pluginSymbol

	| pluginClassName pluginInst |
	pluginSymbol isSymbol ifTrue:[
		pluginClassName := self class name, 'Plugin', pluginSymbol. 
		pluginInst := self pluginInstance registerPlugin: pluginClassName for: self. 
		pluginInst initPlugin: nil]
! !

!MarkupBuilder methodsFor: 'init' stamp: 'Skrish 7/26/2010 00:34'!
initialize
	validator := MarkupValidator getInstance! !

!MarkupBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:34'!
lineEnd
	^ String cr! !

!MarkupBuilder methodsFor: 'handle_markup' stamp: 'Skrish 7/26/2010 00:34'!
modifyArgs: args for: aSelector
	| aTag selectorSet |
	selectorSet := (aSelector subStrings: ':') asOrderedCollection.
	aTag := selectorSet removeFirst.
	args addFirst: aTag.
	(aSelector includes: $:)
		ifFalse: [ args add: '' afterIndex: 1 ].
	(selectorSet includes: 'with')
		ifFalse: [ args addLast: nil ]! !

!MarkupBuilder methodsFor: 'extras' stamp: 'Skrish 7/26/2010 00:34'!
nonTagString: aString
	"To account for the pre processor strings to be included..with some validation if we can.."

	aString asString notEmpty
		ifTrue: [ self valueStream nextPutAll: aString asString ]! !

!MarkupBuilder methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/10/2010 07:56'!
pluginInstance
	pluginInstance ifNil: [ pluginInstance := MarkupBuilderPlugins new ].
	^ pluginInstance! !

!MarkupBuilder methodsFor: 'private' stamp: 'Skrish 7/25/2010 09:50'!
resetAllValues

	attributes := OrderedCollection new.



! !

!MarkupBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:34'!
tag: aTag
	"another polymorphic methods.."

	self tag: aTag text: ''.
	self resetAllValues! !

!MarkupBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:34'!
tag: aTag text: aText
	"another polymorphic methods.."

	self tag: aTag text: aText with: nil! !

!MarkupBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:35'!
tag: aTag text: aText with: nodeBlk
	"another polymorphic methods.."

	| textString attributesCopy |
	textString := aText asString.
	self createTag: aTag text: textString with: nodeBlk.
	attributesCopy := attributes.
	attributes := nil.	"this has go to be nilled here.. to avoid reusing it next run.."
	nodeBlk isNil
		ifFalse: [ self handleBlock: aTag with: nodeBlk ].
	(self testForSelfClosingTag: nodeBlk tag: aText)
		ifFalse: [ self closeTag: aTag with: nodeBlk ]	"self valueStream nextPutAll: self lineEnd."! !

!MarkupBuilder methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:35'!
testForSelfClosingTag: nodeBlk tag: aText
	^ nodeBlk isNil and: [ aText isNil or: [ aText asString isEmpty ] ]! !

!MarkupBuilder methodsFor: 'handle_markup' stamp: 'Skrish 7/7/2010 10:51'!
toggleMethodCreationFor: args
	| aTag nodeBlk attribArray nodeText |
	aTag := args first.
	nodeText := args at: 2.
	nodeBlk := args last.
	validator validateBlkNode: nodeBlk.
	self tag: aTag text: nodeText with: nodeBlk! !

!MarkupBuilder methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 00:35'!
valueStream
	valueStream ifNil: [ valueStream := WriteStream on: '' ].
	^ valueStream! !

!MarkupBuilder methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:35'!
valueStream: aValue
	valueStream := aValue! !

!MarkupBuilder methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:35'!
visitPlugin: selector withArguments: argsArray
	" can do a variant for the specific pluginInstance to respond only .."

	self pluginInstance pluginRegistry values
		do: [ :eaPlugin | 
			((eaPlugin respondsTo: selector) and: [ eaPlugin initialized ])
				ifTrue: [ eaPlugin acceptPlugin: selector withArguments: argsArray ] ]! !

!MarkupBuilder methodsFor: 'private_for_plugin' stamp: 'Skrish 7/25/2010 09:51'!
visitPlugin: selector withArguments: argsArray forPlugin: aSymbol
	"for specific plugin symbol"

	| aPlugin |
	aPlugin := self pluginInstance pluginRegistryAt: aSymbol.
	((aPlugin respondsTo: selector) and: [ aPlugin initialized ])
		ifTrue: [ aPlugin acceptPlugin: selector withArguments: argsArray ]! !

MarkupBuilder subclass: #XMLBuilder
	instanceVariableNames: 'indentTag currentNsPrefix xmlTrim'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

XMLBuilder subclass: #HtmlBuilder
	instanceVariableNames: 'htmlTables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

!HtmlBuilder class methodsFor: 'comment' stamp: 'Skrish 7/5/2010 19:16'!
classInfo

^'@Ref: linksAndInformation
@Ref: http://dev.w3.org/html5/spec/Overview.html
http://www.w3.org/TR/html401/struct/global.html
Also need to consider: http://whatwg.org/html5 that deviates from above..

extend xml builder to add:
* doc metadata: head, title, base, link,  meta
* scriptString: .. presume javascript for now.
http://dev.w3.org/html5/spec/Overview.html#scriptingLanguages
* linkCss:
* linkjs:

stage II:
* support for global attributes: id, title, lang, xml:base, dir, class, style..
* callback: ..? action on say button click.. a href..
* ajax: capability hook..
* linkModel:to: instVar link to component..

stage III:
* helpers for popups, input types, selects or others as deemed reqd.. minimally

stage IV:
* helpers to tag along for JQuery..?, lightbox, dialogs etc..? from Seaside pre-existing stuff as possible..
* onclick, ondblclick, onmousedown, onmouseup, onmouseover, onmousemove, onmouseout, onkeypress, onkeydown, onkeyup (intrinsic events)


@author: 
Skrish;
{author-list}

@date-modified: 
5 July 2010;

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:
htmlTableTag:


@classVars:


@classInstVars:


@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:51'!
baseAttributes: attrColl
	self
		attributes: attrColl;
		tag: 'base' text: ''! !

!HtmlBuilder methodsFor: 'may_change_api' stamp: 'Skrish 7/26/2010 00:51'!
convertToSelectOptionsColl: valuesTextAndSelectedDictionaryColl
	| selectOptionsValueAndTextColl |
	selectOptionsValueAndTextColl := valuesTextAndSelectedDictionaryColl.
	(valuesTextAndSelectedDictionaryColl first isKindOf: Dictionary)
		ifFalse: [ 
			selectOptionsValueAndTextColl := OrderedCollection new.
			valuesTextAndSelectedDictionaryColl first
				do: [ :ea | 
					selectOptionsValueAndTextColl
						add:
							((Dictionary new)
								at: #value put: ea;
								at: #text put: ea;
								yourself).
					ea = valuesTextAndSelectedDictionaryColl last
						ifTrue: [ selectOptionsValueAndTextColl last at: #selected put: true ] ] ].
	^ selectOptionsValueAndTextColl! !

!HtmlBuilder methodsFor: 'html_table' stamp: 'Skrish 7/26/2010 00:51'!
defaultHtmlTable
	^ self htmlTableAt: #default! !

!HtmlBuilder methodsFor: 'html_table' stamp: 'Skrish 7/26/2010 00:51'!
htmlTableAt: aSymbol
	self htmlTables
		at: aSymbol
		ifAbsent: [ self htmlTables at: aSymbol put: (HtmlBuilderTableWidget getHtmlBldrInstance: self) ].
	^ self htmlTables at: aSymbol! !

!HtmlBuilder methodsFor: 'html_table' stamp: 'Skrish 7/26/2010 00:52'!
htmlTables
	htmlTables ifNil: [ htmlTables := Dictionary new ].
	^ htmlTables! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
jsFile: scriptFilename
	| jsAttributes |
	jsAttributes := Array with: 'SRC="' , scriptFilename , '"'.
	self
		attributes: jsAttributes;
		tag: 'script' text: ''! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
jsFileColl: scriptFilenameColl
	scriptFilenameColl do: [ :eaFile | self jsFile: eaFile ]! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
linkCssFile: cssFilename
	"could make the title from filename if not given better tolerance for back or front slash.. or any other name input format"

	self linkCssFile: cssFilename title: ''! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
linkCssFile: cssFilename title: aTitle
	"validate this call is right after head and before body..? or inserted only therein"

	| attrColl |
	attrColl := {(#REL -> 'STYLESHEET').
	(#HREF -> cssFilename)} asOrderedCollection.
	aTitle notEmpty
		ifTrue: [ attrColl add: #TITLE -> aTitle ].
	self
		attributes: attrColl;
		tag: 'link' text: ''! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
linkCssFileColl: cssFilenameColl
	cssFilenameColl do: [ :eaFile | self linkCssFile: eaFile ]! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
metaAttributes: attrColl
	self
		attributes: attrColl;
		tag: 'meta' text: ''! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
metaRefreshTime: secondsCount
	self metaRefreshTime: secondsCount url: nil! !

!HtmlBuilder methodsFor: 'api' stamp: 'Skrish 7/26/2010 00:52'!
metaRefreshTime: secondsCount url: anUrl
	"redirect to anUrl or to the same page if anUrl isNil for charset
	and other variants use the standard bldr syntax"

	| attrColl |
	attrColl := {('http-equiv' -> 'Refresh').
	(#content -> secondsCount)} asOrderedCollection.
	anUrl
		ifNotNil: [ :url | 
			attrColl
				removeLast;
				add: 'content="' , secondsCount asString , '; URL=' , anUrl ].
	self
		attributes: attrColl;
		tag: 'meta' text: ''! !

!HtmlBuilder methodsFor: 'may_change_api' stamp: 'Skrish 7/26/2010 00:52'!
script: scriptString
	"default to javascript and currently not considering src attrib.."

	self script: scriptString language: 'javascript'! !

!HtmlBuilder methodsFor: 'may_change_api' stamp: 'Skrish 7/26/2010 00:52'!
script: scriptString language: lang
	"embed: lang: javascript or vbscript or tcl or..?..?"

	"validation for the string..? contain the js syntax..?.."

	self attributes addAll: {(#type -> ('text/' , lang))}.
	self tag: 'script' text: scriptString! !

!HtmlBuilder methodsFor: 'may_change_api' stamp: 'Skrish 7/26/2010 00:52'!
select: ignoreText optionCNodes: valuesTextAndSelectedDictionaryColl
	"ignorable ignoreText to retain similar method naming convention: may use this arg later for some other purpose..?
valuesTextAndSelectedColl can contain any of the values for the keys #(value text selected)"

	| attrStr selectOptions |
	selectOptions := self convertToSelectOptionsColl: valuesTextAndSelectedDictionaryColl.
	self
		tag: 'select'
		text: ''
		with: [ 
			attrStr := ''.
			selectOptions
				do: [ :eaDict | 
					(eaDict at: #value ifAbsent: [ nil ]) ifNotNil: [ :eaVal | attrStr := 'value="' , eaVal , '"' ].
					(eaDict at: #selected ifAbsent: [ nil ])
						ifNotNil: [ :eaSel | 
							eaSel
								ifTrue: [ attrStr := attrStr , ' selected' ]	"always set the selected true in the dict..for the one option.." ].
					self
						attributes: (Array with: attrStr);
						tag: 'option' text: (eaDict at: #text) ] ]! !

!HtmlBuilder methodsFor: 'may_change_api' stamp: 'Skrish 7/26/2010 00:52'!
space
	"the nbsp; space"

	self plainText: '&nbsp;'! !

!HtmlBuilder methodsFor: 'may_change_api' stamp: 'Skrish 7/26/2010 00:52'!
styleScript: styleString
	self
		attributes: #('type="text/css"');
		tag: 'style' text: styleString! !

HtmlBuilder subclass: #HtmlBuilderCss
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

!HtmlBuilderCss class methodsFor: 'as yet unclassified' stamp: 'Skrish 6/25/2010 18:41'!
defaultTableCss

^'
.table_t1 {
border: 1px solid #888;
}
.thead_tr {
color: white;
background: #8888aa;
halign: center;
}
.odd_tr {
text-align: center; 
}
.even_tr {
background: #cccccc;
text-align: center; 
}'! !

HtmlBuilder subclass: #HtmlBuilderTableWidget
	instanceVariableNames: 'rowTextInputType headerOrientType headerRowColl rowsDataColl tableAttributes rowAttributes headerAttributes csvReader textInputTypeColl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

!HtmlBuilderTableWidget class methodsFor: 'comment' stamp: 'Skrish 7/5/2010 19:16'!
classInfo

^'@Ref: linksAndInformation

@author:
Skrish
{author-list}

@date-modified:28 June 2010

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:
rowTextInputType:
headerOrientType:
headerRowColl:
rowsDataColl:
tblAttr:
hdrAttr:
rowsAttr:



@classVars:



@classInstVars:



@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'! !

!HtmlBuilderTableWidget class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/23/2010 11:18'!
getHtmlBldrInstance: parentBuilder

| aTableTagBuilder |
 aTableTagBuilder := self basicNew initialize.
 aTableTagBuilder valueStream: parentBuilder valueStream.
 aTableTagBuilder xmlTrim: parentBuilder xmlTrim.
 aTableTagBuilder indent: parentBuilder indent.
 ^aTableTagBuilder ! !

!HtmlBuilderTableWidget class methodsFor: 'as yet unclassified' stamp: 'Skrish 6/22/2010 15:31'!
new
" do not want this to be initialized standalone.. only from HtmlBuilder"


self shouldNotImplement ! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:53'!
createDefaultHeaderRow: rowSize
	headerRowColl := OrderedCollection new.
	rowSize do: [ :indx | headerRowColl add: 'C_' , indx asString ].
	^ headerRowColl	"Default column headers.. could also beA/B/C.. like in excel..for easier cell referencing.."! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:53'!
createPropertiesBeans: rowsArrayColl
	| beansColl |
	beansColl := OrderedCollection new.
	rowsArrayColl
		do: [ :eaRow | 
			| aBean |
			aBean := PropertiesBean new.
			headerRowColl with: eaRow do: [ :eaKey :eaValue | aBean elementAt: eaKey put: eaValue ].
			beansColl add: aBean ].
	^ beansColl! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:53'!
csvReader
	csvReader ifNil: [ csvReader := TabOrCsvStreamReader new ].
	^ csvReader! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:34'!
csvReader: anObject
	csvReader := anObject! !

!HtmlBuilderTableWidget methodsFor: 'html_table_api' stamp: 'Skrish 7/26/2010 00:53'!
fromCsvStream: csvStream headerRow: headerSymbol
	""

	| rowsAndHeader rows headerColl rowsColl |
	rowsAndHeader := [ self readCsvToHeaderAndRowsCollection: csvStream ] ensure: [ csvStream close ].
	(#(#topRow #default) includes: headerSymbol)
		ifFalse: [ MarkupBuilderError signalError: #htmlTableCsvHeaderRowSymbol ].
	rows := rowsAndHeader last.
	headerSymbol = #topRow
		ifTrue: [ headerRowColl := rowsAndHeader first ].
	headerSymbol = #default
		ifTrue: [ 
			self createDefaultHeaderRow: rowsAndHeader first size.
			rows := rowsAndHeader last addAll: rowsAndHeader first ].
	self setTableRowsRenderTable: (self createPropertiesBeans: rows)! !

!HtmlBuilderTableWidget methodsFor: 'html_table_api' stamp: 'Skrish 7/26/2010 00:53'!
fromPropertiesBeans: propertiesBeansArray
	""

	headerRowColl := propertiesBeansArray first elementProperties
		inject: OrderedCollection new
		into: [ :aColl :ea | 
			aColl
				add: ea key;
				yourself ].
	self setTableRowsRenderTable: propertiesBeansArray! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 00:53'!
headerAttributes
	headerAttributes ifNil: [ headerAttributes := OrderedCollection new ].
	headerAttributes isSequenceable
		ifFalse: [ ^ headerAttributes := headerAttributes asOrderedCollection ].
	^ headerAttributes! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/10/2010 08:32'!
headerAttributes: anObject
	headerAttributes := anObject! !

!HtmlBuilderTableWidget methodsFor: 'html_table_api' stamp: 'Skrish 7/18/2010 11:39'!
headerCNode: headerTextArray rowsCNodes: rowsArrayColl
	"set the attribs before calling this method to render the table"

	| beansColl |
	headerTextArray isNil
		ifTrue: [ self createDefaultHeaderRow: rowsArrayColl first size ]
		ifFalse: [ headerRowColl := headerTextArray ].
	beansColl := self createPropertiesBeans: rowsArrayColl.
	self setTableRowsRenderTable: beansColl! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 00:53'!
headerOrientType
	"#top or #left"

	headerOrientType ifNil: [ headerOrientType := #top ].
	(#(#top #left) includes: headerOrientType)
		ifFalse: [ MarkupBuilderError signalError: #htmlTableHeaderOrientType ].
	^ headerOrientType! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 6/27/2010 15:29'!
headerOrientType: anObject
	headerOrientType := anObject! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 6/27/2010 15:31'!
headerRowColl
	"can be empty"

	headerRowColl ifNil: [ headerRowColl := OrderedCollection new ].
	^ headerRowColl! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:53'!
readCsvToHeaderAndRowsCollection: csvStream
	" Presume for now:
* The first row is a header and a row with no CR within any cell..
* All other row cells have either int/primitive type with or without quotes.. and quotes are removed for cell values"

	| aColl |
	aColl := self csvReader readCsvToHeaderAndRowsCollection: csvStream.
	^ OrderedCollection with: aColl removeFirst with: aColl! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:54'!
renderAfterTable
	"self plugin: #Paginate renderPaginate: nil."

	self visitPlugin: #renderPaginate withArguments: #(nil)! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:54'!
renderBeforeTable
	"self plugin: #Paginate renderPaginate: nil."

	self visitPlugin: #renderPaginate withArguments: #(nil)! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:54'!
renderContext: aRenderContext
	"self plugin: #Paginate renderContext: aRenderContext."

	self visitPlugin: #renderContext: withArguments: (Array with: aRenderContext) forPlugin: #Paginate! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:54'!
renderHeaderAfter
	"modify this method to plugin subclass call to method..else leave it blank"

	" self plugin: #HrefRows renderHeaderAfter: nil."

	self visitPlugin: #renderHeaderAfter withArguments: #() forPlugin: #HrefRows! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:54'!
renderHeaderBefore
	"modify this method to plugin subclass call to method..else leave it blank"

	" self plugin: #HrefRows renderHeaderBefore: nil."

	self visitPlugin: #renderHeaderBefore withArguments: #() forPlugin: #HrefRows! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:54'!
renderRow: rowText rowIndx: rowIndx colIndx: colIndx
	"handling currently for returning the edited or selected values..!!!!.. on basis of tdIndStr being unique for each cell..wrap it in a form and link it up to javascript and use ajax to send form edited content"

	| tdIdStr aText cNodeBlkAttr textType |
	tdIdStr := 'tr_' , rowIndx asString , '_td_' , colIndx asString.	" can simplify this to just rowIndx_tdIndx if ok.."
	(textType := self textInputTypeCollAt: colIndx) = #none
		ifTrue: [ 
			aText asString isEmpty
				ifTrue: [ aText := ' ' ]
				ifFalse: [ aText := rowText ] ]
		ifFalse: [ 
			cNodeBlkAttr := {(#id -> tdIdStr). (#type -> textType). (#class -> 'trow_td'). 'multiple'} asOrderedCollection.
			textType = #radio | (textType = #checkbox)
				ifTrue: [ aText := rowText ].
			textType = #text | (textType = #submit)
				ifTrue: [ 
					aText := ''.
					cNodeBlkAttr
						add: #value -> rowText;
						yourself ] ].
	self renderTextTag: aText attributes: cNodeBlkAttr! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:55'!
renderRowsAfter: rowIndx
	"modify this method to plugin subclass call to method..else leave it blank"

	" self plugin: #HrefRows renderRowsAfter: rowIndx."

	self visitPlugin: #renderRowsAfter: withArguments: (Array with: rowIndx) forPlugin: #HrefRows! !

!HtmlBuilderTableWidget methodsFor: 'private_for_plugin' stamp: 'Skrish 7/26/2010 00:55'!
renderRowsBefore: rowIndx
	"modify this method to plugin subclass call to method..else leave it blank"

	"self plugin: #HrefRows renderRowsBefore: rowIndx."

	self visitPlugin: #renderRowsBefore: withArguments: (Array with: rowIndx) forPlugin: #HrefRows! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:55'!
renderRowsChildNodes
	| rowAttrStr attrColl |
	self rowsDataColl
		withIndexDo: [ :eaCollRowBean :rowIndx | 
			rowAttrStr := 'odd_tr'.
			rowIndx \\ 2 = 0
				ifTrue: [ rowAttrStr := 'even_tr' ].
			attrColl := (self rowsAttributes copy)
				addAll: {(#class -> rowAttrStr)};
				yourself.
			self
				attributes: attrColl;
				tag: 'tr'
					text: ''
					with: [ 
							self renderRowsBefore: rowIndx.
							(eaCollRowBean elementProperties collect: [ :eaAssoc | eaAssoc value ])
								withIndexDo: [ :eaRowText :colIndx | self renderRow: eaRowText rowIndx: rowIndx colIndx: colIndx ].
							self renderRowsAfter: rowIndx ] ]! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/16/2010 15:32'!
renderTable
	""

	| topOrLeft rowTextType |
	self renderBeforeTable.
	topOrLeft := self headerOrientType.
	self
		attributes: self tableAttributes;
		tag: 'table'
			text: ''
			with: [ 
					topOrLeft = #top
						ifTrue: [ self renderTopHeaderAndRows ].
					topOrLeft = #left
						ifTrue: [ self renderleftHeaderAndRows ] ].
	self renderAfterTable! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:55'!
renderTextTag: aText attributes: nodeAttributes
	nodeAttributes
		ifNil: [ 
			self
				attributes: #('class="trow_td"');
				tag: 'td' text: aText ]
		ifNotNil: [ :cNodeAttr | 
			self
				attributes: #('class="trow_td"');
				tag: 'td'
					text: ' '
					with: [ 
							self
								attributes: nodeAttributes;
								tag: 'input';
								plainText: aText ] ]! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/16/2010 15:33'!
renderTopHeaderAndRows
	| rowsAttribs |
	rowsAttribs := (self headerAttributes copy)
		addFirst: 'class="thead_tr"';
		yourself.
	self
		attributes: rowsAttribs;
		tag: 'tr'
			text: ''
			with: [ 
					self renderHeaderBefore.
					self headerRowColl
						do: [ :eaHeaderText | 
							self
								attributes: #('class=thead_th');
								tag: 'th' text: eaHeaderText ].
					self renderHeaderAfter ].
	self renderRowsChildNodes! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/23/2010 10:53'!
renderleftHeaderAndRows
	| rowText headerAttribs |
	headerAttribs := (self headerAttributes copy)
		addFirst: 'class=thead_th';
		yourself.
	self headerRowColl
		withIndexDo: [ :eaHeaderText :rowIndx | 
			| tdIndStr |
			self
				attributes: #('class="trow_tr"');
				tag: 'tr'
				text: ''
				with: [ 
					self attributes: headerAttribs; tag: 'th' text: eaHeaderText .
					self rowsDataColl
						withIndexDo: [ :eaCollRowBean :colIndx | 
							rowText := (eaCollRowBean  elementProperties at: rowIndx) value.
							self renderRow: rowText rowIndx: rowIndx colIndx: colIndx ] ] ]! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 13:53'!
rowTextInputType
	"#none for plain text, as input : #text, #radio, #checkbox, #submit, #password.., could we also extend to drop downs..?"

	(rowTextInputType isNil or: [ rowTextInputType isEmpty ])
		ifTrue: [ rowTextInputType := #none ].
	^ rowTextInputType! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 6/27/2010 15:37'!
rowTextInputType: anObject
	rowTextInputType := anObject! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/10/2010 08:31'!
rowsAttributes
	rowAttributes ifNil: [ rowAttributes := OrderedCollection new ].
	rowAttributes isSequenceable ifFalse: [ ^rowAttributes := rowAttributes asOrderedCollection ].
	^rowAttributes ! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/10/2010 08:31'!
rowsAttributes: anObject
	rowAttributes := anObject! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 6/27/2010 15:31'!
rowsDataColl
	"can be empty..about.01% times..!!"

	rowsDataColl ifNil: [ rowsDataColl := OrderedCollection new ].
	^ rowsDataColl! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:55'!
setTableRows: rowsArrayColl
	rowsDataColl := rowsArrayColl.
	self visitPlugin: #tableRows: withArguments: (Array with: rowsArrayColl)! !

!HtmlBuilderTableWidget methodsFor: 'private' stamp: 'Skrish 7/18/2010 11:11'!
setTableRowsRenderTable: beansColl

	self setTableRows: beansColl.
	self renderTable! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/10/2010 08:31'!
tableAttributes
	tableAttributes ifNil: [ tableAttributes := OrderedCollection new ].
	tableAttributes isSequenceable ifFalse: [ ^tableAttributes := tableAttributes asOrderedCollection ].
	^tableAttributes ! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/10/2010 08:32'!
tableAttributes: anObject
	tableAttributes := anObject! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:55'!
textInputTypeColl: aCollOfTextInputType
	textInputTypeColl := aCollOfTextInputType! !

!HtmlBuilderTableWidget methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:56'!
textInputTypeCollAt: anIndex
	textInputTypeColl ifNil: [ ^ self rowTextInputType ].
	^ textInputTypeColl at: anIndex ifAbsent: [ ^ self rowTextInputType ]! !

!HtmlBuilderTableWidget methodsFor: 'accessors_read_defaults' stamp: 'Skrish 7/26/2010 00:56'!
valueStream
	^ valueStream ifNil: [ MarkupBuilderError signalError: #valueStreamBeSetByHtmlBuilder ]! !

!XMLBuilder class methodsFor: 'comment' stamp: 'Skrish 6/28/2010 00:15'!
classInfo

^'Ref: http://www.w3.org/TR/REC-xml/
* implemented: XmlDecl, doctype, comment, cdata and the normal node tree..with attribs/ textNode
* validations: no explicit validation: well formedness guaranteed in construction, no schema checks
* DTD: copy over as single string in doctype decl no checks..
* No optimization of null or empty text tags viz: <node/> kinds.. 

@author:
Skrish

@date-modified:19 June 2010

@usage-API:
Refer XMLBuilderTests  >> test*

@Class:
Concrete implementation, extended by HtmlBuilder 

@Instvars:
indentTag:

@classVar:


@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}

'
 



! !

!XMLBuilder class methodsFor: 'init' stamp: 'Skrish 6/18/2010 10:18'!
new

|bldr |
bldr := self basicNew.
bldr initialize.
^bldr! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:49'!
cdata: cdataStr
	self nonTagString: '<!![CDATA[' , cdataStr , ']]>'! !

!XMLBuilder methodsFor: 'subclass_responsibility' stamp: 'Skrish 7/26/2010 00:49'!
closeTag: aTag with: nodeBlk
	| nsTag |
	nsTag := self resolveTagWithNamespace: aTag.
	nodeBlk notNil
		ifTrue: [ 
			self indent: indent - 1.
			self indentSpaces ].
	valueStream nextPutAll: '</' , nsTag , '>'	"; cr"! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:49'!
comment: commentStr
	self nonTagString: '<!!-- ' , commentStr , '-->'! !

!XMLBuilder methodsFor: 'private' stamp: 'Skrish 7/9/2010 10:26'!
copy
	| copy |
	copy := self shallowCopy postCopy.
	copy currentNsPrefix: nil.
	^ copy! !

!XMLBuilder methodsFor: 'subclass_responsibility' stamp: 'Skrish 7/26/2010 00:50'!
createTag: aTag text: aText with: nodeBlk
	"store the initial markups for nodeTag its test and attibutes"

	| nsTag |
	nsTag := self resolveTagWithNamespace: aTag.
	self indentSpaces.
	(self valueStream)
		nextPutAll: '<' , nsTag;
		nextPutAll: (utilityClassInstance createAttributesStringFromColl: self attributes).
	(self testForSelfClosingTag: nodeBlk tag: aText)
		ifTrue: [ self valueStream nextPutAll: ' /' ].
	(self valueStream)
		nextPutAll: '>';
		nextPutAll: aText asString! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:50'!
currentNsPrefix
	""

	^ currentNsPrefix! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:50'!
currentNsPrefix: namespacePrefix
	"let us presume it is already defined in call to xmlnsPrefix:nsUrl:"

	currentNsPrefix := namespacePrefix! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:50'!
docType: docTypeStr
	self nonTagString: '<!!DOCTYPE ' , docTypeStr , '>'! !

!XMLBuilder methodsFor: 'subclass_responsibility' stamp: 'Skrish 7/26/2010 00:50'!
handleBlock: aTag with: blkNode
	| blkValue nsTag |
	nsTag := self resolveTagWithNamespace: aTag.
	self indent: self indent + 1.
	self indentTag: nsTag.
	blkNode value! !

!XMLBuilder methodsFor: 'overrides' stamp: 'Skrish 7/25/2010 10:03'!
indentSpaces

	xmlTrim ifTrue: [ ^self "do nothing"].
	self valueStream position > 1 ifTrue: [
	self valueStream nextPutAll: self lineEnd].
	self indent timesRepeat: [	self valueStream nextPutAll: '    '] .! !

!XMLBuilder methodsFor: 'accessors' stamp: 'Skrish 7/26/2010 00:50'!
indentTag
	indentTag ifNil: [ indentTag := '' ].
	^ indentTag! !

!XMLBuilder methodsFor: 'accessors' stamp: 'Skrish 7/26/2010 00:50'!
indentTag: aVal
	indentTag := aVal! !

!XMLBuilder methodsFor: 'init' stamp: 'Skrish 7/26/2010 00:50'!
initialize
	utilityClassInstance := XMLMarkupUtility getInstance.
	validator := XMLBuilderValidator getInstance.
	xmlTrim := false! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:50'!
nonTagString: aString
	(validator validateAddlStmtPrefix: aString)
		ifFalse: [ MarkupBuilderError signalError: #xmlAddlStmtPrefixNotValid ].
	super nonTagString: aString! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:50'!
plainText: aString
	super nonTagString: aString! !

!XMLBuilder methodsFor: 'private' stamp: 'Skrish 7/9/2010 10:26'!
resolveTagWithNamespace: aTag
	self currentNsPrefix ifNil: [ ^ aTag ] ifNotNil: [ :e | ^ currentNsPrefix , ':' , aTag ]! !

!XMLBuilder methodsFor: 'accessors' stamp: 'Skrish 7/26/2010 00:50'!
valueString
	^ self valueStream contents! !

!XMLBuilder methodsFor: 'extras' stamp: 'Skrish 7/26/2010 00:50'!
valueStringTrimmed
	"this is not a correct replacement logic.. blanks inside text/Attribute tag will get truncated..!!"

	| xmlString |
	xmlString := self valueString copyReplaceAll: '    ' with: ''.
	^ xmlString copyReplaceAll: self lineEnd with: ''! !

!XMLBuilder methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:50'!
xmlDecl: versionNum encoding: encodingStr
	"Omitting standalone for now.. "

	self valueStream nextPutAll: '<?xml version=' , versionNum , ' encoding=' , encodingStr , '?>'! !

!XMLBuilder methodsFor: 'private' stamp: 'Skrish 7/26/2010 00:50'!
xmlPreprocessor
	self valueStream nextPutAll: '<?xml version="1.0" ?>'! !

!XMLBuilder methodsFor: 'accessing' stamp: 'Skrish 7/19/2010 10:49'!
xmlTrim
	^ xmlTrim! !

!XMLBuilder methodsFor: 'accessing' stamp: 'Skrish 7/19/2010 10:49'!
xmlTrim: anObject
	xmlTrim := anObject! !

!XMLBuilder methodsFor: 'OtherStatements' stamp: 'Skrish 7/26/2010 00:51'!
xmlnsPrefix: namespacePrefix nsUrl: anUrl
	self attributes add: (Association key: 'xmlns:' , namespacePrefix value: anUrl)! !

Object subclass: #MarkupBuilderPlugins
	instanceVariableNames: 'pluginParent pluginRegistry initialized pluginBlockInvoked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML-Plugins'!

MarkupBuilderPlugins subclass: #HtmlBuilderTableWidgetPluginHrefRows
	instanceVariableNames: 'hrefRowsAfter hrefRowsBefore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML-Plugins'!

!HtmlBuilderTableWidgetPluginHrefRows class methodsFor: 'comment' stamp: 'Skrish 7/5/2010 19:17'!
classInfo

^'@Ref: linksAndInformation

@author:
Skrish
{author-list}

@date-modified: 28 June 2010;28 June 2010

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:
hrefRowsAfter:
hrefRowsBefore:
pluginParent:


@classVars:


@classInstVars:


@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'href_rows_extension' stamp: 'Skrish 6/25/2010 21:10'!
hrefRowsAfter: theHrefRowsAfter

hrefRowsAfter := theHrefRowsAfter! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'href_rows_extension' stamp: 'Skrish 6/25/2010 21:10'!
hrefRowsBefore: theHrefRowsBefore

hrefRowsBefore := theHrefRowsBefore! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'href_rows_extension' stamp: 'Skrish 7/5/2010 18:51'!
initPlugin: nilObj


initialized := true.! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'overrides' stamp: 'Skrish 7/16/2010 15:32'!
renderHeaderAfter
	hrefRowsAfter ifNotNil: [ :hrefRows | self renderHeaderHrefRows: hrefRows ]! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'overrides' stamp: 'Skrish 7/16/2010 15:33'!
renderHeaderBefore
	hrefRowsBefore ifNotNil: [ :hrefRows | self renderHeaderHrefRows: hrefRows ]! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'overrides' stamp: 'Skrish 7/23/2010 20:17'!
renderHeaderHrefRows: hrefRows

	hrefRows do: [ :eaRow | pluginParent tag: 'th' asString text: ' ' ]! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'overrides' stamp: 'Skrish 6/25/2010 20:36'!
renderRowsAfter: rowIndx

	hrefRowsAfter ifNotNil: [ :hrefRows | self renderRowsHref: hrefRows indx: rowIndx]! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'overrides' stamp: 'Skrish 6/25/2010 20:36'!
renderRowsBefore: rowIndx

	hrefRowsBefore ifNotNil: [ :hrefRows | self renderRowsHref: hrefRows indx: rowIndx ]! !

!HtmlBuilderTableWidgetPluginHrefRows methodsFor: 'overrides' stamp: 'Skrish 7/26/2010 00:57'!
renderRowsHref: hrefRows indx: rowIndx
	| attrColl |
	hrefRows
		do: [ :eaRowText | 
			pluginParent
				tag: 'td'
				text: ' '
				with: [ 
					attrColl := {(#href -> (eaRowText , '_' , rowIndx asString))}.
					pluginParent
						attributes: attrColl;
						tag: 'a' text: eaRowText ] ]! !

MarkupBuilderPlugins subclass: #HtmlBuilderTableWidgetPluginPaginate
	instanceVariableNames: 'totalPages numRows tableRows placement currentPage renderContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML-Plugins'!

!HtmlBuilderTableWidgetPluginPaginate class methodsFor: 'comment' stamp: 'Skrish 7/5/2010 19:18'!
classInfo

^'@Ref: linksAndInformation

@author: 
Skrish;
{author-list}

@date-modified: 
5 July 2010;

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:
totalPages:
currPage:
numRows:
tableRows:
rel2TblLoc: relative to the table location #top or bottom or #both..


@classVars:


@classInstVars:


@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'overrides' stamp: 'Skrish 7/26/2010 00:57'!
acceptPlugin: selector withArguments: argsArray
	"this is rather stupid.. I add no value to the overridden method of the super class per se.."

	selector = #renderContext:
		ifTrue: [ self renderContext: argsArray first ].
	selector = #renderPaginate
		ifTrue: [ self renderPaginate ].
	selector = #tableRows:
		ifTrue: [ self tableRows: argsArray first ]! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:57'!
currentPage
	(currentPage isNil or: [ currentPage > self totalPages ])
		ifTrue: [ currentPage := 1 ].
	^ currentPage min: self totalPages! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/16/2010 08:52'!
currentPage: anObject
	| indx |
	currentPage := (anObject min: self totalPages) max: 1.
	
	"indx := pluginParent class allInstVarNames indexOf: #rowsDataColl.
	pluginParent instVarAt: indx put: (self dataCollForPage: self currentPage)."! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'api' stamp: 'Skrish 7/15/2010 10:41'!
dataCollForPage: pageNum
	"return the collection for the req page"

	| startIndx endIndx |
	(pageNum < 1 or: [ pageNum > totalPages ])
		ifTrue: [ ^ 'doNothing' ].
	"currPage := pageNum."
	startIndx := (pageNum - 1) * numRows + 1.
	endIndx := tableRows size min: startIndx + numRows -1 .
	^ tableRows copyFrom: startIndx to: endIndx! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'api' stamp: 'Skrish 6/28/2010 15:02'!
firstPage

^self dataCollForPage: 1.! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 18:51'!
initPlugin: nilObj

initialized := true

! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'api' stamp: 'Skrish 6/28/2010 15:02'!
lastPage

^self dataCollForPage: totalPages. ! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 12:55'!
numRows

numRows ifNil: [ numRows := 10].
	^ numRows! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 12:18'!
numRows: anObject
	numRows := anObject! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'overrides' stamp: 'Skrish 7/26/2010 01:01'!
paginateHtml
"after or before or both.. of the table emitted.. 
first prev 1 2 3 4 5 10 15 20 25 30 ... next last 
need to deal with href links.. later
"


#( 'first' 'prev' ) do: [ :ea | | eaPg|
	(ea = 'first') ifTrue: [eaPg := 1].
	(ea = 'prev') ifTrue: [eaPg := self currentPage -1].
	pluginParent  attributes:  (self renderPageLink: eaPg); a: ea ; space ].

totalPages > 10 ifTrue: [ 
	1 to: 4 do: [:eaPg | pluginParent attributes: (self renderPageLink: eaPg); a: eaPg asString ; space ].
	1 to: totalPages/5 do: [ :eaPg | pluginParent attributes:  (self renderPageLink: eaPg*5); a:( eaPg*5) asString ; space ].	
	]
   ifFalse: [
	1 to: totalPages do: [:eaPg | pluginParent attributes:  (self renderPageLink: eaPg); a: eaPg asString ; space ].	
	].

#( 'next' 'last' ) do: [ :ea | | eaPg|
	(ea = 'next') ifTrue: [eaPg := self currentPage + 1].
	(ea = 'last') ifTrue: [eaPg := self totalPages].	
	pluginParent  attributes:   (self renderPageLink: eaPg); a: ea ; space].

! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:02'!
placement
	"#top or bottom.."

	placement ifNil: [ placement := #both ].
	^ placement! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/9/2010 13:09'!
placement: anObject
	placement := anObject! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'overrides' stamp: 'Skrish 7/26/2010 01:02'!
renderContext: aRenderContext
	"If we have a Seaside app and the renderContext be set.."

	renderContext := aRenderContext! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'overrides' stamp: 'Skrish 7/26/2010 01:24'!
renderPageLink: pageNumber
	| aBlock aSelector url pageNum |
	renderContext ifNil: [ ^ {#href->('link_' , pageNum asString)} ].
	pageNum := (pageNumber min: self totalPages) max: 1.
	aSelector := ('currentPage_' , pageNum asString) asSymbol.
	aBlock := [ :pgNum |  pluginBlockInvoked := true.
						 self currentPage: pgNum asNumber ].
	url := HtmlBuilderComponent new storeActionCallback: aBlock on: renderContext value: pageNum.
	(url queryFields)
		at: #pgNum put: pageNum;
		yourself.
	^{#href->(url asString)}! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'overrides' stamp: 'Skrish 7/26/2010 01:04'!
renderPaginate
	| indx |
	self setValues.
	indx := pluginParent class allInstVarNames indexOf: #rowsDataColl.
	pluginParent instVarAt: indx put: (self dataCollForPage: self currentPage).
	self paginateHtml! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'api' stamp: 'Skrish 6/28/2010 15:06'!
setRowsForPage: pageNum
	| pageRows |
	(pageRows := self dataCollForPage: pageNum) ifNil: [ ^ nil ].
	pluginParent instVarAt: (pluginParent class instVarNames indexOf: #rowsDataColl) put: pageRows! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/16/2010 12:04'!
setValues

	| rem |

	(tableRows size \\ self numRows) > 0 ifTrue: [ rem := 1] ifFalse: [ rem := 0].
	totalPages := (tableRows size / self numRows + rem) asInteger! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 12:18'!
tableRows
	^ tableRows! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 12:18'!
tableRows: anObject
	tableRows := anObject! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 12:18'!
totalPages
	^ totalPages! !

!HtmlBuilderTableWidgetPluginPaginate methodsFor: 'accessing' stamp: 'Skrish 7/5/2010 12:18'!
totalPages: anObject
	totalPages := anObject! !

MarkupBuilderPlugins subclass: #MarkupBuilderPluginDummy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML-Plugins'!

!MarkupBuilderPluginDummy class methodsFor: 'comment' stamp: 'Skrish 6/28/2010 02:18'!
classInfo

^'@Ref: linksAndInformation

@author: 
Skrish;
{author-list}

@date-modified: 
28 June 2010;

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:


@classVars:


@classInstVars:


@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'! !

!MarkupBuilderPluginDummy methodsFor: 'as yet unclassified' stamp: 'Skrish 6/28/2010 01:36'!
doesNotUnderstand: aMessage
"do nothing as a good dummy should"! !

!MarkupBuilderPlugins class methodsFor: 'comment' stamp: 'Skrish 6/28/2010 02:17'!
classInfo

 ^'@Ref: linksAndInformation

@author: 
Skrish;
{author-list}

@date-modified: 28 June 2010;

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:
pluginParent:
pluginRegistry:

@classVars:



@classInstVars:



@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'! !

!MarkupBuilderPlugins class methodsFor: 'as yet unclassified' stamp: 'Skrish 7/16/2010 11:56'!
setPluginParent: aParent

| newInstance |
 newInstance := self basicNew.
 newInstance parent: aParent .
 newInstance pluginBlockInvoked: false.
^newInstance
! !

!MarkupBuilderPlugins methodsFor: 'plugin_api' stamp: 'Skrish 7/26/2010 00:56'!
acceptPlugin: selector withArguments: argsArray
	"can be overriden by subclasses if specialization is required viz: see **Paginate "

	self perform: selector withArguments: argsArray! !

!MarkupBuilderPlugins methodsFor: 'plugin_api' stamp: 'Skrish 7/26/2010 00:56'!
dummyPlugin: pluginSymbol for: aClassObj
	" put up a dummy plugin to override temporarily if reqd within the same method process. "

	| pluginInst pluginClassName |
	self removePlugin: pluginSymbol forClass: aClassObj class name.
	pluginInst := MarkupBuilderPluginDummy setPluginParent: aClassObj.
	pluginClassName := aClassObj class name , 'Plugin' , pluginSymbol.
	pluginRegistry at: pluginClassName put: pluginInst! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:56'!
initialized
	initialized ifNil: [ initialized := false ].
	^ initialized! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:56'!
parent: aParent
	pluginParent := aParent! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 7/16/2010 11:56'!
pluginBlockInvoked
	^ pluginBlockInvoked! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 7/16/2010 11:56'!
pluginBlockInvoked: anObject
	pluginBlockInvoked := anObject! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 6/28/2010 02:02'!
pluginParent 

^pluginParent ! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 13:19'!
pluginRegistry 
	"Why not object dependents dictionary.. see registerPlugin:*"

	pluginRegistry ifNil: [pluginRegistry := Dictionary new].
	^pluginRegistry 
! !

!MarkupBuilderPlugins methodsFor: 'accessing' stamp: 'Skrish 7/16/2010 16:36'!
pluginRegistryAt: aSymbol

	^self pluginRegistry detect: [ :ea | ea class name endsWith: aSymbol asString] ifNone: [nil]
! !

!MarkupBuilderPlugins methodsFor: 'plugin_api' stamp: 'Skrish 7/26/2010 13:32'!
registerPlugin: pluginClassName for: aClassObj
	"Current design is on per instance of the builder used.. basis.."

	| pluginClass pluginInst |
	self flag: #checkLater.	
	"Could be using the standard object dependents instead of pluginRegistry... Need to check on the benefit of moving out there.."
	
	^ self pluginRegistry
		at: pluginClassName
		ifAbsent: [ 
			pluginClass := Smalltalk
				at: pluginClassName asSymbol
				ifAbsent: [ MarkupBuilderError signal: 'Plugin: ' , pluginClassName , ' : Not Found' ].	" consider to change this to warning.. and continue if on runtime.. with an error note..?"
			pluginInst := pluginClass setPluginParent: aClassObj.
			pluginRegistry at: pluginClassName put: pluginInst ].

	"^aClassObj dependents 
			detect: [ :ea | ea class = aClassObj class  ] 
			ifNone: [ 
				pluginClass := Smalltalk
					at: pluginClassName asSymbol
					ifAbsent: [ ^MarkupBuilderError signal: 'Plugin: ' , pluginClassName , ' : Not Found' ].
				pluginInst := pluginClass setPluginParent: aClassObj.
				aClass addDependent: pluginInst]. "! !

!MarkupBuilderPlugins methodsFor: 'plugin_api' stamp: 'Skrish 7/26/2010 00:56'!
reinitializePlugin: pluginSymbol for: anObj
	| pluginClassName |
	self removePlugin: pluginSymbol forClass: anObj class name.
	pluginClassName := anObj class name , 'Plugin' , pluginSymbol.
	self registerPlugin: pluginClassName for: anObj! !

!MarkupBuilderPlugins methodsFor: 'plugin_api' stamp: 'Skrish 7/26/2010 13:19'!
removePlugin: pluginSymbol forClass: aClassSymbol
	"simpler to do removeDependent: if object dependents are used.. see registerPlugin: * .. "
	
 	| pluginClass pluginInst pluginClassName |
	pluginClassName := aClassSymbol , 'Plugin', pluginSymbol. 
	self pluginRegistry at: pluginClassName ifAbsent: [^false].
	pluginRegistry removeKey: pluginClassName.
	^true! !

Object subclass: #MarkupUtility
	instanceVariableNames: ''
	classVariableNames: 'singletonInstance'
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

!MarkupUtility class methodsFor: 'comment' stamp: 'Skrish 6/28/2010 02:15'!
classCommentTemplate
"classComment is a method of some use... change to classInfo to avoid any clash.."
	^ 'classInfo

^''@Ref: linksAndInformation

@author:
{author-list}

@date-modified:

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instVars:

@classVars:

@classInstVars:

@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}


'''! !

!MarkupUtility class methodsFor: 'instance creation' stamp: 'Skrish 7/26/2010 00:39'!
getInstance
	"The singleton instance..? work it out"

	^ self basicNew! !

!MarkupUtility class methodsFor: 'instance creation' stamp: 'Skrish 7/26/2010 00:39'!
new
	self shouldNotImplement! !

!MarkupUtility methodsFor: 'as yet unclassified' stamp: 'Skrish 7/26/2010 00:42'!
blockAsArray: aBlock
	" need to do this better.. use this in BlockClosure class..substitute aBlock with 'self' below "

	| stmts anArray |
	stmts := aBlock decompile statements.
	anArray := Array new: stmts size.
	stmts
		doWithIndex: [ :eaNode :indx | anArray at: indx put: (Compiler evaluate: eaNode for: aBlock outerContext receiver logged: false) first ].
	^ anArray! !

!MarkupUtility methodsFor: 'as yet unclassified' stamp: 'Skrish 7/26/2010 00:42'!
createClassCommentTemplateFor: aClassSymbol
	"some utility methods to dump comments for the classes..
Modify @author value below.."
	"self getInstance createClassCommentTemplateFor: #MarkupBuilder  "

	| theClass templateString valueDict aVar |
	theClass := Smalltalk at: aClassSymbol.
	(theClass class selectors includes: #classInfo)
		ifTrue: [ 
			(StandardWindow new questionWithoutCancel: 'May overwrite classInfo method..?' title: 'Compile classInfo')
				ifFalse: [ ^ self ].
			templateString := 'classInfo\\ ^''' withCRs , theClass classInfo , '''' ]
		ifFalse: [ templateString := self class classCommentTemplate ].
	valueDict := (Dictionary new)
		at: '@instVars:' put: theClass instVarNames;
		at: '@classVars:' put: theClass classPool associations;
		at: '@classInstVars:' put: theClass class instVarNames;
		yourself.
	#('@date-modified:' '@author:')
		with: (Array with: Date today asString with: 'Skrish')
		do: [ :eaKey :eaVal | templateString := templateString copyReplaceAll: eaKey with: eaKey , ' \' withCRs , eaVal , ';' ].
	valueDict associations
		do: [ :eaAssoc | 
			| aStr |
			eaAssoc value
				ifNotNil: [ :ea | 
					aStr := eaAssoc value
						inject: ''
						into: [ :str :eaVar | 
							aVar := eaVar.
							aVar isString
								ifFalse: [ aVar := eaVar key asString ].
							str , aVar , ':\' withCRs ].
					aStr := eaAssoc key , '\' withCRs , aStr.
					templateString := templateString copyReplaceAll: eaAssoc key with: aStr ] ].
	theClass class compile: templateString classified: 'comment'! !

MarkupUtility subclass: #XMLMarkupUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

!XMLMarkupUtility methodsFor: 'helper methods' stamp: 'Skrish 7/26/2010 00:56'!
createAttributesStringFromColl: asscCollOrDictOfAttr
	| attrStream |
	attrStream := WriteStream on: ''.
	asscCollOrDictOfAttr
		do: [ :eaAsscOrString | 
			eaAsscOrString isString
				ifTrue: [ attrStream nextPutAll: ' ' , eaAsscOrString ]
				ifFalse: [ 
					attrStream
						nextPutAll: ' ' , eaAsscOrString key;
						nextPut: $=;
						nextPut: $";
						nextPutAll: eaAsscOrString value asString;
						nextPutAll: '"' ] ].
	^ attrStream contents! !

Object subclass: #MarkupValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

!MarkupValidator class methodsFor: 'comment' stamp: 'Skrish 7/5/2010 19:12'!
classInfo

^'@Ref: linksAndInformation

@author:
{author-list}
Skrish

@date-modified:19 June 2010

@usage-API:
{None}

@Class:
{Abstract / Concrete}

@instvars:

@classVars:



@classInstVars:
singletonInstance:



@instMethods:
{main api or subclass resposibility methods}

@classMethods:
{main instance creation or api methods}

'! !

!MarkupValidator class methodsFor: 'instance creation' stamp: 'Skrish 7/26/2010 00:39'!
getInstance
	"Work it out for Singleton instance"

	^ self basicNew! !

!MarkupValidator class methodsFor: 'instance creation' stamp: 'Skrish 7/26/2010 00:39'!
new
	self shouldNotImplement! !

!MarkupValidator methodsFor: 'validation' stamp: 'Skrish 7/26/2010 00:41'!
validateBlkNode: blkNode
	(blkNode isNil or: [ blkNode class = BlockClosure ])
		ifFalse: [ MarkupBuilderError signalError: #cNodeNotBlockType ]! !

!MarkupValidator methodsFor: 'validation' stamp: 'Skrish 7/26/2010 00:41'!
validateForBuilder: args with: selector
	"Raise exception if not ok"

	| firstArg selectorSet |
	selectorSet := (selector asString subStrings: ':') asOrderedCollection.
	self validateForMultipleArgs: args.
	args isEmpty
		ifFalse: [ 
			firstArg := args first.
			selectorSet removeFirst.
			(selectorSet asSet copyWithoutAll: #('with')) ifNotEmpty: [ MarkupBuilderError signalError: #bldrAllowedArgs ] ]! !

!MarkupValidator methodsFor: 'validation' stamp: 'Skrish 7/26/2010 00:42'!
validateForMultipleArgs: args
	args size > 2
		ifTrue: [ MarkupBuilderError signalError: #bldrMaxArgs ]! !

MarkupValidator subclass: #XMLBuilderValidator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-XML'!

!XMLBuilderValidator methodsFor: 'validation' stamp: 'Skrish 7/26/2010 00:56'!
validateAddlStmtPrefix: aString
	"check if we can insert comments..CDATA sections... etc.. "

	^ (RxMatcher forString: '<!!.*') matches: aString! !

Object subclass: #PropertiesBean
	instanceVariableNames: 'beanAlias attributeProperties elementProperties elementPrefix text markupBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Core'!

!PropertiesBean class methodsFor: 'comment' stamp: 'Skrish 6/28/2010 00:14'!
classInfo

^'
Ref: Groovy or Java Bean.. as the motivation to map a class with its vars as markup..

@author:
Skrish
@date-modified:19 June 2010

@usage-API:
{None}

@usage:
Refer PropertiesBeanTests >> test*

@Class:
Use as is with alias or subclass and specialize as rqd.

@instvars:
beanAlias:
attributeProperties:
elementProperties:
attribElementPrefix:
elementPrefix:
text:
mkupBldr:

@classVars:


@classInstVars:



@instMethods:
createChildNode:
createRecursiveBldrBlock:

@classMethods:
{main instance creation or api methods}


'! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 21:41'!
attributeAt: aKey 
	
	^attributeProperties 
		detect: [ :ea | ea key = aKey ]
		ifNone: [ nil ].
! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 21:36'!
attributeAt: aKey put: aValue 
	| anAttibute |
	anAttibute := attributeProperties 
		detect: [ :ea | ea key = aKey ]
		ifNone: [ 
			attributeProperties add: (Association key: aKey value: aValue).
			nil ].
	anAttibute ifNotNil: [ anAttibute value: aValue ]! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 6/3/2010 13:00'!
attributeProperties

^attributeProperties! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:40'!
beanAlias
	" simple but very effective for using one single class to instantiate all nodes with the alias as reqd for the tagName"

	beanAlias ifNil: [ beanAlias := self class name ].
	^ beanAlias! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 6/9/2010 07:15'!
beanAlias: anObject
	beanAlias := anObject! !

!PropertiesBean methodsFor: 'createMarkupBlock' stamp: 'Skrish 7/26/2010 00:40'!
createChildNode
	"reached bcos all elements are basic text nodes so return the node filled in as a block"

	| attribArray recursivelyResolvedElemBlock attribStr blkColl |
	blkColl := OrderedCollection new.
	elementProperties do: [ :eaElem | blkColl add: [ markupBuilder tag: eaElem key asString text: eaElem value ] ].
	^ [(self markupBuilder)
		attributes: attributeProperties;
		tag: self beanAlias text: self text with: [ blkColl do: [ :ea | ea value ] ] ]! !

!PropertiesBean methodsFor: 'createMarkupBlock' stamp: 'Skrish 7/26/2010 00:41'!
createRecursiveBldrBlock
	"from the given bean instance build up the block that contains the attributes and elements with recursion for bean instances inside eleelementProperties .. if all elementPrelementProperties are of text type return the childNode ( leaf) Return a block that will be realized as per the message finally sent with a specific builder instantiated therein viz: xmlString"

	| recursivelyResolvedElemBlock blkColl |
	elementProperties detect: [ :eaElem | eaElem isKindOf: PropertiesBean ] ifNone: [ ^ self createChildNode ].
	blkColl := OrderedCollection new.
	elementProperties
		do: [ :eaElem | 
			(eaElem isKindOf: PropertiesBean)
				ifTrue: [ eaElem markupBuilder: markupBuilder.
						blkColl add: eaElem createRecursiveBldrBlock ]
				ifFalse: [ blkColl add: [ markupBuilder tag: eaElem key asString text: eaElem value ] ] ].
	^ [markupBuilder
		attributes: attributeProperties;
		tag: self beanAlias
			text: self text
			with: [blkColl
						do: [ :ea | 
							| tmp |
							(tmp := ea value) isBlock
								ifTrue: [ tmp value ] ] ] ]! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 21:41'!
elementAt: aKey

	^elementProperties
		detect: [ :ea | ea key = aKey ]
		ifNone: [ nil ].
! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 21:36'!
elementAt: aKey put: aValue
	| anElement |
	anElement := elementProperties
		detect: [ :ea | ea key = aKey ]
		ifNone: [ 
			elementProperties add: (Association key: aKey value: aValue).
			nil ].
	anElement ifNotNil: [ anElement value: aValue ]! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 00:41'!
elementPrefix: aPrefix
	"check if we need to validate the prefix string..aNamespace addOn.."

	elementPrefix := aPrefix! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 6/3/2010 13:00'!
elementProperties

^elementProperties ! !

!PropertiesBean methodsFor: 'init' stamp: 'Skrish 7/26/2010 00:41'!
initialize
	attributeProperties := OrderedCollection new.	"should be OC of Associations of attribElement to: value"
	elementProperties := OrderedCollection new	"should be OC of Associations of elementTag to: text or node"! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/10/2010 08:05'!
markupBuilder

^markupBuilder! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/10/2010 08:03'!
markupBuilder: aXMLBldr 

markupBuilder := aXMLBldr ! !

!PropertiesBean methodsFor: 'convertion' stamp: 'Skrish 7/23/2010 11:05'!
printOn: aStream

aStream nextPutAll: self xmlString! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 21:44'!
removeAttributeAt: aKey
	| anAttribute |
	anAttribute := attributeProperties 
		detect: [ :ea | ea key = aKey ]
		ifNone: [^nil ].
	anAttribute ifNotNil: [^attributeProperties remove: anAttribute]! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 7/14/2010 21:44'!
removeElementAt: aKey 
	| anElement |
	anElement := elementProperties
		detect: [ :ea | ea key = aKey ]
		ifNone: [ ^nil ]. 
	anElement ifNotNil: [ ^elementProperties remove: anElement  ]! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 6/3/2010 11:47'!
text
	^ text! !

!PropertiesBean methodsFor: 'accessing' stamp: 'Skrish 6/3/2010 11:47'!
text: anObject
	text := anObject! !

!PropertiesBean methodsFor: 'convertion' stamp: 'Skrish 7/26/2010 00:41'!
xmlString
	"consider if this can be chucked.. in favor of using Trimmed: method"

	markupBuilder := XMLBuilder new xmlPreprocessor.
	self createRecursiveBldrBlock value.
	^ markupBuilder valueString! !

!PropertiesBean methodsFor: 'convertion' stamp: 'Skrish 7/26/2010 00:41'!
xmlStringTrimmed: trim
	markupBuilder := XMLBuilder new xmlPreprocessor xmlTrim: trim.
	self createRecursiveBldrBlock value.
	^ markupBuilder valueString! !

PropertiesBean subclass: #Trial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

PropertiesBean subclass: #TrialChild
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Tests'!

Object subclass: #TabOrCsvStreamReader
	instanceVariableNames: 'lineEnd fieldDelimiter quoteString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MarkupBuilder-Utils'!

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
fieldDelimiter
	fieldDelimiter ifNil: [ fieldDelimiter := ',' ].
	^ fieldDelimiter! !

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:15'!
fieldDelimiter: fieldDelimiterChar 


fieldDelimiter := fieldDelimiterChar
! !

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
lineEnd
	lineEnd ifNil: [ lineEnd := String cr ].	" should make the default be picked from Platform preference"
	^ lineEnd! !

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:15'!
lineEnd: crOrCrLf 


lineEnd := crOrCrLf! !

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
lineEnd: crOrCrLf fieldDelimiter: fieldDelimiterStr quoteString: quoteStr
	lineEnd := crOrCrLf.
	fieldDelimiter := fieldDelimiterStr.
	quoteString := quoteStr! !

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/26/2010 01:04'!
quoteString
	quoteString ifNil: [ quoteString := '"' ].
	^ quoteString! !

!TabOrCsvStreamReader methodsFor: 'accessing' stamp: 'Skrish 7/23/2010 10:22'!
quoteString: quoteStr

quoteString := quoteStr! !

!TabOrCsvStreamReader methodsFor: 'read' stamp: 'Skrish 7/26/2010 01:21'!
readCsvToHeaderAndRowsCollection: csvReadStream
	" Presume for now:
* The first row is a header and a row with no CR within any cell..
* All other row cells have either int/primitive type with or without quotes.. and quotes are removed for cell values"

	|  firstRow headerRow columnCount rowsColl row |
	firstRow := csvReadStream upToAll: self lineEnd.
	headerRow := (firstRow subStrings: self fieldDelimiter) collect: [ :ea | ea trimBoth withoutQuoting ].
	columnCount := headerRow size.
	rowsColl := OrderedCollection with: headerRow.
	[ csvReadStream atEnd ] whileFalse: [ rowsColl add: (self readEachRow: csvReadStream upto: columnCount) ].
	^ rowsColl! !

!TabOrCsvStreamReader methodsFor: 'read' stamp: 'Skrish 7/26/2010 01:22'!
readEachRow: csvReadStream upto: columnCount
	| row |
	row := OrderedCollection new.
	1 to: columnCount do: [ :indx | 
		| elems |
		csvReadStream peek = self quoteString first
			ifTrue: [	elems := self quoteString.
					csvReadStream next ]
			ifFalse: [ 
				indx = columnCount
					ifFalse: [ elems := self fieldDelimiter ]
					ifTrue: [ elems := self lineEnd ] ].
		row add: (csvReadStream upToAll: elems) trimBoth withoutQuoting.
		self
			skipEndChars: elems
			for: columnCount
			on: csvReadStream
			at: indx.
		(row last hasWideCharacterFrom: 1 to: row last size)
			ifTrue: [ row
						removeLast;
						add: 'ERROR: CELL HAD WIDE CHAR' ]	"need to recheck on this.. to handle it better" ].
	^ row! !

!TabOrCsvStreamReader methodsFor: 'read' stamp: 'Skrish 7/26/2010 01:20'!
skipEndChars: elems for: columnCount on: csvReadStream at: indx
	"skip chars: ',' or crOrCrlf at end of fields..'"

	elems = self quoteString
		ifTrue: [ 
			indx ~= columnCount
				ifTrue: [ 
					| aChar |
					aChar := Character space.
					[ aChar = Character space ] whileTrue: [ aChar := csvReadStream next ].
					aChar = self fieldDelimiter first
						ifFalse: [ self halt	"it must get the fieldDelimiter here and skip ahead" ]	" skip $," ].
			indx = columnCount
				ifTrue: [ csvReadStream upToAll: self lineEnd	" remove the crORcrlf " ] ]! !
MarkupBuilderError initialize!
MarkupBuilderWarning initialize!
TestBeanBuilder initialize!
TestHtmlBuilder initialize!
TestHtmlBuilderTableTests initialize!
TestXmlBuilder initialize!
SeasideTests initialize!
